#include <exec/types.h>
#include <stdlib.h>
#include <intuition/screens.h>
#include <exec/lists.h>
#include <exec/nodes.h>
#include <novia/novia_UserList.h>
#include <novia/novia_PortData.h>
#include <novia/novia_config.h>
#include <novia/novia_mail.h>
#include <novia/novia_types.h>
#include <novia/novia_misc.h>
#include <novia/novia_message.h>
#include <novia/novia_dos.h>
#include <pragma/exec_lib.h>
#include <pragma/dos_lib.h>
#include <pragma/noviasys_lib.h>
#include <exec/memory.h>
#include <dos/stdio.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <novia/novia_funcs.h>
#include <novia/novia_registers.h>
//#include "/protos/novia_dos_protos.h"
#include <pragma/noviasys_lib.h>
#include <exec/semaphores.h>
#include <utility/tagitem.h>
#include <dos/dostags.h>


extern struct MainPortConfig *mainportconfig;

extern Library *NoviaSysBase;
extern struct NFSServer *nfsserver;
extern struct List *client_list;
extern struct Task *MainTask;
extern struct SignalSemaphore *rt_semaphore;



/*** prototypes for DOS-API ***/


Directory * __saveds ASM nslib_mkdir	(register __a0 char *name);
LONG __saveds ASM nslib_closeroot		();
LONG __saveds ASM nslib_openroot			();
LONG __saveds ASM nslib_parrentdir		();
LONG __saveds ASM nslib_list				();
LONG __saveds ASM nslib_changedir		(register __a0 char *name);
LONG __saveds ASM nslib_delete			(register __a0 char *name);
LONG __saveds ASM nslib_addmail			(register __a0 struct NewItem *item);
LONG __saveds ASM nslib_addreply			(register __a0 char *itemname,					register __a1 char *replyname);
LONG __saveds ASM nslib_loadselectlist	(register __a0 List *select_list);
LONG __saveds ASM nslib_saveselectlist	(register __a0 List *select_list);
LONG __saveds ASM nslib_getlist			();
LONG __saveds ASM nslib_tstselect		(register __a0 char *inputstring);
LONG __saveds ASM nslib_additementry	(register __a0 struct ItemEntry *itementry);
LONG __saveds ASM nslib_additementry2dir(register __a0 struct Directory *dir,		register __a1 struct ItemEntry *itementry);
LONG __saveds ASM nslib_addmail2dir		(register __a0 Directory *dir,					register __a1 struct NewItem *item);
LONG __saveds ASM nslib_closedir			(register __a0 Directory *dir);
void __saveds ASM nslib_readmessage		(register __a0 ItemEntryBlock *ieb);
LONG __saveds ASM nslib_sendmail			(register __a0 NewMail *newmail);
LONG __saveds ASM nslib_uucp_import_mail(register __a0 char *filename);
LONG __saveds ASM nslib_readmailbox		(register __a0 ItemEntryBlock *ieb);
LONG __saveds ASM nslib_rename			(register __a0 char *oldname,						register __a1 char *newname);
LONG __saveds ASM nslib_editflags		(register __a0 char *name);
LONG __saveds ASM nslib_info				(register __a0 char *name);
LONG __saveds ASM nslib_execute			(register __a0 char *name);
struct ItemEntryBlock * __saveds ASM nslib_get_ieb			(register __a0 char *name);
LONG 					LowLevelCommand_makefilesystem();
LONG 					LowLevelCommand_makeroot		();
LONG 					LowLevelCommand_adddirectory	(char *name);
LONG 					LowLevelCommand_addlink			(char *name);
LONG 					LowLevelCommand_addcommand		(char *name);
void execute_novia_dos_program();
void AddLocalDir(struct Directory *dirtoadd, struct PortData *cport);
LONG __saveds ASM nslib_load_ndos_object(register __a0 char *name, register __a1 APTR ptr);
LONG __saveds ASM nslib_save_ndos_object(register __a0 char *name, register __a1 APTR ptr);


/*** external functions ***/


extern struct ItemEntryBlock *nfs_support_get_ieb(char *name, PortData *cport);
extern void SetIPCounter64(ULONG *ptr);



LONG DoNFSPacket(LONG action, LONG arg1, LONG arg2, LONG arg3, LONG arg4, LONG arg5, PortData *cport)
{
	LONG result = FALSE;
	if (cport && nfsserver)
	{
		if (cport->nfs_port)
		{
			struct NFSPacket *packet;				// Send Packet
			struct NFSPacket *recv_packet;		// recieve packet
			List	 			  recv_list;			// packet list for other recieve packets
			BOOL				  quit = FALSE;
			NewList(&recv_list);
			if ((packet = AllocVec(sizeof(NFSPacket),MEMF_ANY|MEMF_CLEAR)))
			{
				packet->nfs_cport					= cport;
				packet->nfs_msg.mn_ReplyPort	= cport->nfs_port;
				packet->nfs_type					= action;
				packet->nfs_arg1					= arg1;
				packet->nfs_arg2					= arg2;
				packet->nfs_arg3					= arg3;
				packet->nfs_arg4					= arg4;
				packet->nfs_arg5					= arg5;
				PutMsg(nfsserver->nfs_port, (Message *)packet);
				while (!quit)
				{
					if (WaitPort(cport->nfs_port))
					{
						if ((recv_packet = (NFSPacket *)GetMsg(cport->nfs_port)))
						{
							if (recv_packet == packet)		// check for own sended packet, quit, then recieve packet is sended packet.
							{
								result 	= recv_packet->nfs_result1;
								quit		= TRUE;
							}
							else
							{
								AddTail(&recv_list,(Node *)recv_packet);	// add to list, then packet is't a other packet.
							}
						}
					}
				}
				recv_packet = (NFSPacket *)recv_list.lh_Head;
				while (recv_packet->nfs_msg.mn_Node.ln_Succ)		// add other recieved packets to nfsport.
				{
					PutMsg(cport->nfs_port, (Message *)recv_packet);
					recv_packet = (NFSPacket *)recv_packet->nfs_msg.mn_Node.ln_Succ;
				}
				FreeVec(packet);											// give used memory free of own packet.
			}
		}
	}
	return(result);
}

/* initiate an NFSPacket */

void SendNFSPacket(NFSPacket *packet,		PortData *cport)
{
	if (cport && nfsserver && cport->nfs_port)
	{
		packet->nfs_cport					= cport;
		packet->nfs_msg.mn_ReplyPort	= cport->nfs_port;
		PutMsg(nfsserver->nfs_port, (Message *)packet);
	}
}

NFSPacket * WaitNFSPacket(PortData *cport)
{
	struct NFSPacket *result = NULL;
	if (cport && nfsserver && cport->nfs_port)
	{
		if (WaitPort(cport->nfs_port))
			result = (NFSPacket *)GetMsg(cport->nfs_port);
	}
	return(result);
}

NFSPacket * AbortNFSPacket(struct NFSPacket *packet)
{
	struct NFSPacket *result = NULL;
	if (packet)
	{
		Forbid();
		if (!packet->nfs_inprocess)
		{
			Remove((Node *)packet);
			result = packet;
		}
		Permit();
	}
	return(result);
}

void ReplyNFSPacket( struct NFSPacket *packet)
{
	if (packet)
		ReplyMsg((Message *)packet);
}


Directory * __saveds ASM nslib_mkdir(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	struct Directory *result = NULL;
	result = (Directory *)DoNFSPacket(ACTION_NFS_MAKEDIR, (LONG)name, 0, 0, 0, 0, cport);
	return result;
}


LONG __saveds ASM nslib_closeroot()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_CLOSEROOT, 0, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_openroot()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_OPENROOT, 0, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_parrentdir()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_PARENTDIR, 0, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_changedir(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_CHANGEDIR, (LONG)name, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_delete(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_DELETE, (LONG)name, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_addmail(register __a0 struct NewItem *item)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_ADDMAIL, (LONG)item, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_addreply(register __a0 char *itemname,	register __a1 char *replyname)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_ADDREPLY, (LONG)itemname, (LONG)replyname, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_loadselectlist(register __a0 List *select_list)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_LOADSELECTLIST, (LONG)select_list, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_saveselectlist(register __a0 List *select_list)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_SAVESELECTLIST, (LONG)select_list, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_getlist()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_GETLIST, 0, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_additementry(register __a0 struct ItemEntry *itementry)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_ADDITEMENTRY, (LONG)itementry, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_additementry2dir(register __a0 struct Directory *dir, register __a1 struct ItemEntry *itementry)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_ADDITEMENTRY2DIR, (LONG)dir, (LONG)itementry, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_addmail2dir(register __a0 Directory *dir,	register __a1 struct NewItem *item)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_ADDMAIL2DIR, (LONG)dir, (LONG)item, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_closedir(register __a0 Directory *dir)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_CLOSEDIR, (LONG)dir, 0, 0, 0, 0, cport);
	return result;
}

LONG __saveds ASM nslib_sendmail(register __a0 NewMail *newmail)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_SENDMAIL, (LONG)newmail, 0, 0, 0, 0, cport);
	return result;
}


LONG __saveds ASM nslib_uucp_import_mail(register __a0 char *filename)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	return(DoNFSPacket(ACTION_NFS_UUCP_IMPORT_MAIL, (LONG)filename, 0, 0, 0, 0, cport));
}


LONG __saveds ASM nslib_rename(register __a0 char *oldname, register __a1 char *newname)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_NFS_RENAME, (LONG)oldname, (LONG)newname, 0, 0, 0, cport);
	if (result)
	{
		ioprintf("can't rename %s, %s\n",oldname, getstr(150, (UWORD)result));
	}
	else
	{
		ioprintf("%s renamed in %s\n",oldname, newname);
	}
	return result;
}

struct ItemEntryBlock * __saveds ASM nslib_get_ieb(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	struct ItemEntryBlock *result = NULL;
	result = (struct ItemEntryBlock *)DoNFSPacket(ACTION_NFS_GET_IEB, (LONG)name, 0, 0, 0, 0, cport);
	return(result);
}

LONG LowLevelCommand_makefilesystem()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_LOWLEVEL_MAKE_FILESYSTEM, 0, 0, 0, 0, 0, cport);
	return(result);
}

LONG LowLevelCommand_makeroot()
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_LOWLEVEL_MAKE_ROOT, 0, 0, 0, 0, 0, cport);
	return(result);
}

LONG LowLevelCommand_adddirectory(char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_LOWLEVEL_ADD_DIRECTORY, (LONG)name, 0, 0, 0, 0, cport);
	return(result);
}

LONG LowLevelCommand_addlink(char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_LOWLEVEL_ADD_LINK, (LONG)name, 0, 0, 0, 0, cport);
	return(result);
}

LONG LowLevelCommand_addcommand(char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	result = DoNFSPacket(ACTION_LOWLEVEL_ADD_COMMAND, (LONG)name, 0, 0, 0, 0, cport);
	if (result)
	{
		ioprintf("can't add command %s, %s\n",name,getstr(150,(UWORD)result));
	}
	else
	{
		ioprintf("%s added\n",name);
	}
	return(result);
}


LONG __saveds ASM nslib_readmailbox(register __a0 ItemEntryBlock *ieb)
{
	LONG result = NULL;
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		INet_EMail_Entry *inet_email_entry= NULL;
		ULONG			pos;
		BOOL			nostdcmd	= TRUE;
		BOOL			readnew	= TRUE;
		BOOL			quit		= TRUE;
		ULONG			cmdid		= 0;
		char *fullpath = cport->currentdir->iib.fullpath;

		ULONG			length_fp = strlen(fullpath);
		char			*buffer;

		if ((buffer = AllocVec(strlen(cport->currentdir->iib.fullpath) + 128, MEMF_ANY)))
		{
			if ((inet_email_entry = AllocVec(sizeof(INet_EMail_Entry),MEMF_ANY)))
			{
				struct INet_EMail *inet_email;
				if ((inet_email = AllocVec(sizeof(INet_EMail), MEMF_ANY | MEMF_CLEAR)))
				{
					BPTR fh_mails  = NULL;
					BPTR fh_fields = NULL;
					ULONG length;
					if (fullpath)
					{
						if (length_fp)
						{
							printf("fullpaht: %s\n",fullpath);
							if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
							{
								sprintf(buffer,"%s.inet_messages",fullpath);
								fh_mails = Open(buffer,MODE_READWRITE);
								sprintf(buffer,"%s.inet_field_entrys",fullpath);
								fh_fields = Open(buffer,MODE_READWRITE);
								if (!cport->currentdir->fh_text)
								{
									sprintf(buffer,"%s.text",cport->currentdir->iib.fullpath);
									cport->currentdir->fh_text = Open(buffer,MODE_READWRITE);
								}
							}
							else
							{
								sprintf(buffer,"%s/.inet_messages",fullpath);
								fh_mails = Open(buffer,MODE_READWRITE);
								sprintf(buffer,"%s/.inet_field_entrys",fullpath);
								fh_fields = Open(buffer,MODE_READWRITE);
								if (!cport->currentdir->fh_text)
								{
									sprintf(buffer,"%s/.text",cport->currentdir->iib.fullpath);
									cport->currentdir->fh_text = Open(buffer,MODE_READWRITE);
								}
							}
						}
						if (fh_mails && fh_fields && cport->currentdir->fh_text)
						{
							char *fieldbuffer;
							INet_EMail_Entry *email = NULL;
							while (!email && Read(fh_mails, inet_email_entry, sizeof(INet_EMail_Entry)) == sizeof(INet_EMail_Entry))
							{
								if (ieb->IPNumber64 == inet_email_entry->iib.IPNumber64 && ieb->IPNumber == inet_email_entry->iib.IPNumber)
									email = inet_email_entry;
								ioprintf("inet_email_entry: %d %d\n",inet_email_entry->iib.IPNumber64, inet_email_entry->iib.IPNumber);
							}
							if (email)
							{
								CopyMemQuick(inet_email_entry, inet_email, sizeof(INet_EMail));
								NewList(&inet_email->fieldlist);
								if (Seek(cport->currentdir->fh_text, email->seek + email->headersize, OFFSET_BEGINNING) != -1)
								{
									if ((inet_email->text = AllocVec(email->textsize - email->headersize, MEMF_ANY | MEMF_CLEAR)))
									{
										char *fieldbuffer;
										if (Read(cport->currentdir->fh_text, inet_email->text, email->textsize - email->headersize) != -1)
										{
											if ((fieldbuffer = AllocVec(email->FieldSize, MEMF_ANY)))
											{
												if (Seek(fh_fields, email->FirstField, OFFSET_BEGINNING) != -1)
												{
													if (Read(fh_fields, fieldbuffer, email->FieldSize) != -1)
													{
														char *fieldptr = fieldbuffer;
														char *end		= fieldbuffer + email->FieldSize;
														char quit		= FALSE;
														char fieldsize;
														char usernamesize;
														char realnamesize;
														ULONG fieldid;
														struct INet_User_Address	*inet_user_address;
														struct INet_Field_Entry		*inet_field_entry;
														struct INet_String			*inet_string;
														while (fieldptr < fieldbuffer && !quit)
														{
															CopyMem(fieldptr, &fieldid, 4);
															fieldptr = fieldptr + 4;
															if (fieldid == INET_FIELD_ID_X_ENVELOPE_FROM | fieldid == INET_FIELD_ID_X_ENVELOPE_TO | fieldid == INET_FIELD_ID_FROM | fieldid == INET_FIELD_ID_TO | fieldid == INET_FIELD_ID_SENDER | fieldid == INET_FIELD_ID_REPLY_TO | fieldid == INET_FIELD_ID_CC | fieldid == INET_FIELD_ID_BCC | fieldid == INET_FIELD_ID_RETURN_RECEIPT_TO | fieldid == INET_FIELD_ID_DISPOSITION_NOTIFICATION_TO)
															{
																fieldsize    = *fieldptr++;
																if ((inet_user_address = AllocVec(sizeof(INet_User_Address), MEMF_ANY | MEMF_CLEAR)))
																{
																	usernamesize = *fieldptr++;
																	inet_user_address->field.fieldid	= fieldid;
																	inet_user_address->field.fieldtype = INET_FIELD_TYPE_USER_ADDRESS;
																	if (usernamesize > 1)
																	{
																		if ((inet_user_address->UserName = AllocVec(usernamesize, MEMF_ANY | MEMF_CLEAR)))
																			strncpy(inet_user_address->UserName, fieldptr, usernamesize - 1);
																		else
																		{
																			result = ERROR_OUT_OF_MEMORY;
																			quit = TRUE;
																		}
																	}
																	fieldptr = fieldptr + usernamesize;
																	realnamesize = *fieldptr++;
																	if (realnamesize > 1)
																	{
																		if ((inet_user_address->RealName = AllocVec(realnamesize, MEMF_ANY | MEMF_CLEAR)))
																			strncpy(inet_user_address->RealName, fieldptr, realnamesize - 1);
																		else
																		{
																			result = ERROR_OUT_OF_MEMORY;
																			quit = TRUE;
																		}
																	}
																	fieldptr = fieldptr + realnamesize;
																	AddTail((List *)&inet_email->fieldlist, (Node *)inet_user_address);
																}
																else
																{
																	result = ERROR_OUT_OF_MEMORY;
																	quit = TRUE;
																}

															}
															else if (fieldid = INET_FIELD_ID_MESSAGE_ID | fieldid == INET_FIELD_ID_ORGANIZATION | fieldid == INET_FIELD_ID_X_MAILER)
															{
																if ((inet_string = AllocVec(sizeof(INet_String), MEMF_ANY | MEMF_CLEAR)))
																{
																	inet_user_address->field.fieldid	= fieldid;
																	inet_user_address->field.fieldtype = INET_FIELD_TYPE_USER_ADDRESS;
																	if (fieldsize > 1)
																	{
																		if ((inet_string->string = AllocVec(fieldsize, MEMF_ANY | MEMF_CLEAR)))
																		{
																			strncpy(inet_string->string, fieldptr, fieldsize);
																		}
																	}
																	fieldptr = fieldptr + fieldsize;
																}
																else
																{
																	result = ERROR_OUT_OF_MEMORY;
																	quit = TRUE;
																}
															}
															else
															{
																fieldptr = fieldptr + fieldsize;
															}
														}
													}
													else
														result = IoErr();
												}
												else
													result = IoErr();
											}
											else
												result = ERROR_OUT_OF_MEMORY;
										}
										else
											result = IoErr();
									}
									else
										result = ERROR_OUT_OF_MEMORY;
								}
								else
									result = IoErr();
							}
							else
							{
								ioprintf("can't find ipnumber: %d.%d\n",ieb->IPNumber64, ieb->IPNumber);
								result = ERROR_OBJECT_NOT_FOUND;
							}
							if (!result)
							{
								while (!quit && !cport->ProgramClose && cport->network.online)
								{
									if (readnew)
									{
										CLS();
										ioprintf("\nz4c7Mail    :z0c3 (%d of %d) - c2\n",ieb->IDNumber,cport->LocalUser.EMails);
										ioprintf("z4c7Subject :z0c7 %s\n",inet_email->iib.Title);
//										{
//											ioprintf("z4c7From    :z0c3 %s (%u)\n",mail->From,mail->FromUser);
//											ioprintf("z4c7To      :z0c3 %s (%u)\n",mail->To,mail->ToUser);
//										}
										DateToString(buffer, &ieb->LastChange, 0);
										ioprintf("z4c7on      :z0c3 %s\n",buffer);
										{
											ULONG lines = 0;
											char  *buf			= inet_email->text;
											char  *linestart  = inet_email->text;
											char  chars;
											while (lines < 18 && *buf)
											{
												chars = 0;
												while (*buf && *buf != 10 && *buf != 13  && chars < 79)
												{
													buf++;
													chars++;
												}
												lines++;
												Writeio(linestart,buf - linestart);
												Writeio("\n",-1);
												if (*buf == 10 | *buf == 13)
													linestart = buf++ +1;
												else
													linestart = buf;
											}
											while (*buf && !cport->ProgramClose && cport->network.online)
											{
												Writeio("-- press any key to continue.",-1);
												WaitKey(0);
												lines = 0;
												while (lines < 18 && *buf)
												{
													chars = 0;
													while (*buf && *buf != 10 && *buf != 13 && chars < 79)
													{
														buf++;
														chars++;
													}
													lines++;
													Writeio("[8H[M[26H[K",-1);
													Writeio(linestart,buf - linestart);
													Writeio("\n",-1);
													if (*buf == 10 | *buf == 13)
														linestart = buf++ +1;
													else
														linestart = buf;
												}
											}
										}
									}
								}
							}
							readnew = FALSE;
						}
						else
						{
							result = ERROR_OBJECT_NOT_FOUND;
							ioprintf("sdsddffsd \n");
						}
					}
					else
					{
						ioprintf("not path\n");
						result = ERROR_OBJECT_NOT_FOUND;
					}
					FreeVec(inet_email);
				}
				else
					result = ERROR_OUT_OF_MEMORY;
				FreeVec(inet_email_entry);
			}
			else
				result = ERROR_OUT_OF_MEMORY;
			FreeVec(buffer);
		}
		else
			result = ERROR_OUT_OF_MEMORY;
	}
	return(result);
}


LONG __saveds ASM nslib_list()
{
	ndos_execute("novia:sbin/list");
	return FALSE;
}


LONG __saveds ASM nslib_tstselect( register __a0 char *inputstring)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	struct ItemEntryBlock *ieb;
	if (strlen(inputstring))
	{
		if (*inputstring=='*')
		{
			{
				ULONG from=0;
				ULONG to=0;
				ULONG ulong;
				char *pt=inputstring;
				while (*pt)
				{
					if (*pt >= 48 && *pt <= 57)
					{
						StrToLong(pt,(long *)&from);
						while (*pt >= 48 && *pt <= 57)
							pt++;
						if (*pt=='-')
						{
							while (*pt && (*pt<48|*pt>57))
								pt++;
							if (*pt >= 48 && *pt <= 57)
							{
								StrToLong(pt,(long *)&to);
								while (*pt >= 48 && *pt <= 57)pt++;
								if (from>to)
								{
									ulong=to;
									to=from;
									from=ulong;
								}
								if (!from)from = 1;
						 
//								for (ulong = from; (ulong <= (cport->itementrylist.dirs + cport->itementrylist.files) && ulong <= to); ulong++)
								{
									ieb = cport->itementrylist.lh_Head;
									while (ieb->ln_Succ)
									{
										if (ieb->IDNumber >= from && ieb->IDNumber <= to)
										{
											if (ieb->selected)
											{
												ieb->selected = FALSE;
												ioprintf("c3item c7%d c3is now deselected\n",ieb->IDNumber);
											}
											else
											{
												ieb->selected = TRUE;
												ioprintf("c3item c7%d c3is now selected\n",ieb->IDNumber);
											}

										}
										ieb = ieb->ln_Succ;
									}
								}
							}
							else
							{
//								if (from && from <= indexheader.Entrys)

								ieb = cport->itementrylist.lh_Head;
								while (ieb->ln_Succ)
								{
									if (ieb->IDNumber >= from)
									{
										if (ieb->selected)
										{
											ieb->selected = FALSE;
											ioprintf("c3item c7%d c3is now deselected\n",ieb->IDNumber);
										}
										else
										{
											ieb->selected = TRUE;
											ioprintf("c3item c7%d c3is now selected\n",ieb->IDNumber);
										}
									}
									ieb = ieb->ln_Succ;
								}
							}
						}
						else
						{
//							if (from>0 && from<=indexheader.Entrys)
							{
								ieb = cport->itementrylist.lh_Head;
								while (ieb->ln_Succ)
								{
									if (ieb->IDNumber == from)
									{
										if (ieb->selected)
										{
											ieb->selected = FALSE;
											ioprintf("c3item c7%d c3is now deselected\n",ieb->IDNumber);
										}
										else
										{
											ieb->selected = TRUE;
											ioprintf("c3item c7%d c3is now selected\n",ieb->IDNumber);
										}
									}
									ieb = ieb->ln_Succ;
								}
							}
						}
					}
					else
					{
						if (*pt=='-')
						{
							while (*pt && (*pt<48|*pt>57))
								pt++;
							if (*pt>=48 && *pt<=57)
							{
								StrToLong(pt,(long *)&to);
								ieb = cport->itementrylist.lh_Head;
								while (ieb->ln_Succ)
								{
									if (ieb->IDNumber <= to)
									{
										if (ieb->selected)
										{
											ieb->selected = FALSE;
											ioprintf("c3item c7%d c3is now deselected\n",ieb->IDNumber);
										}
										else
										{
											ieb->selected = TRUE;
											ioprintf("c3item c7%d c3is now selected\n",ieb->IDNumber);
										}
									}
									ieb = ieb->ln_Succ;
								}
							}
						}
					}
					if(*pt)pt++;
				}
				ieb = cport->itementrylist.lh_Head;
				while (ieb->ln_Succ)
				{
					Select *select = (Select *)cport->select_list.mlh_Head;
					Select *founded = NULL;
					while (!founded && select->ln_Succ)
					{
						if (ieb->ItemType == ITEMTYPE_SUBBOARD)
						{
							if (select->directoryIP == ieb->IPNumber && select->directoryIP64 == ieb->IPNumber64)
								founded = select;
						}
						else
						{
							if (ieb->ItemType == ITEMTYPE_MESSAGE)
								if (select->directoryIP	== cport->currentdir->iib.IPNumber && select->itemIP64 == ieb->IPNumber64 && select->itemIP == ieb->IPNumber)
									founded = select;
						}						
						select = select->ln_Succ;
					}
					if (founded)
					{
						if (!ieb->selected)
						{
							Remove((Node *)founded);
							if (founded->dirpath)FreeVec(founded->dirpath);
							if (founded->filepath)FreeVec(founded->filepath);
							FreeVec(founded);
						}
					}
					else
					{
						if (ieb->selected)
						{
							if ((select = AllocVec(sizeof(Select),MEMF_ANY|MEMF_CLEAR)))
							{
								if ((select->dirpath = AllocVec(strlen(cport->currentdir->iib.fullpath)+1,MEMF_ANY|MEMF_CLEAR)))
									strcpy(select->dirpath,cport->currentdir->iib.fullpath);

								if ((select->filepath = AllocVec(strlen(ieb->Title)+2,MEMF_ANY|MEMF_CLEAR)))
									strcpy(select->filepath,ieb->Title);

								if (ieb->ItemType == ITEMTYPE_MESSAGE)
								{
									select->directoryIP	= cport->currentdir->iib.IPNumber;
									select->itemIP			= ieb->IPNumber;
									select->itemIP64		= ieb->IPNumber64;
								}
								else
								{
									select->directoryIP	= ieb->IPNumber;
									select->directoryIP64= ieb->IPNumber64;
									select->itemIP			= 0;
									select->itemIP64		= 0;
								}
								AddTail((List *)&cport->select_list,(Node *)select);
							}
						}
					}
					ieb = ieb->ln_Succ;
				}
			}
		}
	}
	return NULL;
}


void __saveds ASM nslib_readmessage(register __a0 ItemEntryBlock *ieb)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		ItemEntry	*item		= NULL;
		ReplyEntry	*reply	= NULL;
		BOOL			nostdcmd	= TRUE;
		BOOL			readnew	= TRUE;
		BOOL			quit		= TRUE;
		ULONG			pos		= 1;
		ULONG			cmdid		= 0;
		if ((item = AllocVec(sizeof(ItemEntry),MEMF_ANY)))
		{
			if ((reply = AllocVec(sizeof(ReplyEntry),MEMF_ANY)))
			{
				char buffer[100];
				char *readbuffer;
				if (!cport->currentdir->fh_files)
				{
					if ((readbuffer = AllocVec(strlen(cport->currentdir->iib.fullpath)+20,MEMF_ANY)))
					{
						sprintf(readbuffer,"%s/.files",cport->currentdir->iib.fullpath);
						cport->currentdir->fh_files = Open(readbuffer,MODE_READWRITE);
						FreeVec(readbuffer);
					}
				}
				if (!cport->currentdir->fh_text)
				{
					if ((readbuffer = AllocVec(strlen(cport->currentdir->iib.fullpath)+20,MEMF_ANY)))
					{
						sprintf(readbuffer,"%s/.text",cport->currentdir->iib.fullpath);
						cport->currentdir->fh_text = Open(readbuffer,MODE_READWRITE);
						FreeVec(readbuffer);
					}
				}
				if (!cport->currentdir->fh_replys)
				{
					if ((readbuffer = AllocVec(strlen(cport->currentdir->iib.fullpath)+20,MEMF_ANY)))
					{
						sprintf(readbuffer,"%s/.replys",cport->currentdir->iib.fullpath);
						cport->currentdir->fh_replys = Open(readbuffer,MODE_READWRITE);
						FreeVec(readbuffer);
					}
				}
				if (cport->currentdir->fh_files)
				{
					BOOL founded = FALSE;
					Seek(cport->currentdir->fh_files, 0, OFFSET_BEGINNING);
					while (quit && (Read(cport->currentdir->fh_files,item,sizeof(ItemEntry)) == sizeof(ItemEntry)))
					{
						if (item->iib.IPNumber == ieb->IPNumber)
							quit = FALSE;
					}
					while (!quit && !cport->ProgramClose && cport->network.online)
					{
						if (readnew)
						{
							if (pos == 1)
							{
								CLS();
								ioprintf("\nz4c7Item    :z0c3 (%d, %d replys) - c2SerialID: %05d.%05d.00001\n",item->iib.IDNumber,item->replys,item->DirIP,item->iib.IPNumber);
								ioprintf("z4c7Subject :z0c7 %s\n",item->iib.Title);
								ioprintf("z4c7From    :z0c3 %s (%u)\n",item->From,item->FromUser);
								ioprintf("z4c7To      :z0c3 %s (%u)\n",item->To,item->ToUser);
								DateToString(buffer,&item->iib.LastChange,0);
								ioprintf("z4c7on      :z0c3 %s\n",buffer);
								if (cport->currentdir->fh_text)
								{
									char *readbuffer;
									if (Seek(cport->currentdir->fh_text, item->text_seek, OFFSET_BEGINNING) != -1)
									{
										if ((readbuffer = AllocVec(item->length + 5,MEMF_ANY|MEMF_CLEAR)))
										{
											if (Read(cport->currentdir->fh_text, readbuffer, item->length) == item->length)
											{
												ULONG lines = 0;
												char  *buf			= readbuffer;
												char  *linestart  = readbuffer;
												char  chars;

												while (lines < 18 && *buf)
												{
													chars = 0;
													while (*buf && *buf != 10 && *buf != 13  && chars < 79)
													{
														buf++;
														chars++;
													}
													lines++;
													Writeio(linestart,buf - linestart);
													Writeio("\n",-1);
													if (*buf == 10 | *buf == 13)
														linestart = buf++ +1;
													else
														linestart = buf;
												}
												while (*buf && !cport->ProgramClose && cport->network.online)
												{
													Writeio("-- press any key to continue.",-1);
													WaitKey(0);
													lines = 0;
													while (lines < 18 && *buf)
													{
														chars = 0;
														while (*buf && *buf != 10 && *buf != 13 && chars < 79)
														{
															buf++;
															chars++;
														}
														lines++;
														Writeio("[6H[M[24H[K",-1);
														Writeio(linestart,buf - linestart);
														Writeio("\n",-1);
														if (*buf == 10 | *buf == 13)
															linestart = buf++ +1;
														else
															linestart = buf;
													}
												}
											}
											FreeVec(readbuffer);
										}
									}
								}
							}
							else
							{
								if (cport->currentdir->fh_replys && item->first_reply != -1)
								{
									CLS();
									ioprintf("\nz4c7Reply   :z0c3 (%d of %d) - c2SerialID: %05d.%05d.%05d\n",pos-1,item->replys,item->DirIP,item->iib.IPNumber,pos-1);
									ioprintf("z4c7From    :z0c3 %s (%u)\n",reply->From, reply->FromUser);
									ioprintf("z4c7To      :z0c3 %s (%u)\n",reply->To, reply->ToUser);
									DateToString(buffer,&reply->LastChange,0);
									ioprintf("z4c7on      :z0c3 %s\n",buffer);
									if (cport->currentdir->fh_text)
									{
										char *readbuffer;
										if (Seek(cport->currentdir->fh_text, reply->text_seek, OFFSET_BEGINNING) != -1)
										{
											if ((readbuffer = AllocVec(reply->length,MEMF_ANY|MEMF_CLEAR)))
											{
												if (Read(cport->currentdir->fh_text, readbuffer, reply->length) == reply->length)
												{
													ULONG lines = 0;
													char  *buf			= readbuffer;
													char  *linestart  = readbuffer;
													char  chars;
	
													while (lines < 18 && *buf)
													{
														chars = 0;
														while (*buf && *buf != 10 && *buf != 13  && chars < 79)
														{
															buf++;
															chars++;
														}
														lines++;
														Writeio(linestart,buf - linestart);
														Writeio("\n",-1);
														if (*buf == 10 | *buf == 13)
															linestart = buf++ +1;
														else
															linestart = buf;
													}
													while (*buf && !cport->ProgramClose && cport->network.online)
													{
														Writeio("-- press any key to continue.",-1);
														WaitKey(0);
														lines = 0;
														while (lines < 18 && *buf)
														{
															chars = 0;
															while (*buf && *buf != 10 && *buf != 13  && chars < 79)
															{
																buf++;
																chars++;
															}
															lines++;
															Writeio("[6H[M[24H[K",-1);
															Writeio(linestart,buf - linestart);
															Writeio("\n",-1);
															if (*buf == 10 | *buf == 13)
																linestart = buf++ +1;
															else
																linestart = buf;
														}
													}
												}
												FreeVec(readbuffer);
											}
										}
									}
								}
							}
							readnew = FALSE;
						}
						ioprintf("\ncmd:>");
						*buffer = 0;
						Getstring(buffer,0,50,0,0);
						GetArg(buffer);
						cmdid = GetCommandID(cport->argstring[0]);
						nostdcmd = TRUE;
						if (!cmdid)
						{
							ULONG ulong = 0;
							if (strlen(cport->argstring[0]))
							{
								if (*cport->argstring[0]!='*')
								{
									StrToLong(cport->argstring[0],(long *)&ulong);
									if (ulong >= 0 && ulong <= item->replys)
									{
										if (ulong == 0)
										{
											if (*cport->argstring[0] == '0')
											{
												pos = 1;
												readnew = TRUE;
											}
										}
										else
										{
											if (cport->currentdir->fh_replys)
											{
												pos = 1;
												if (Seek(cport->currentdir->fh_replys, item->first_reply, OFFSET_BEGINNING) != -1)
												{														
													Read(cport->currentdir->fh_replys, reply, sizeof(ReplyEntry));
													while (pos++ < ulong)
													{
														Seek(cport->currentdir->fh_replys, reply->next_reply, OFFSET_BEGINNING);
														Read(cport->currentdir->fh_replys, reply, sizeof(ReplyEntry));
													}
													readnew=TRUE;
												}
											}
										}
									}
									else
									{
										ioprintf("\n%s: Unknown command\n",cport->argstring[0]);
										readnew=FALSE;
									}
								}
							}
							else
							{
								if (pos <= item->replys && cport->currentdir->fh_replys && item->first_reply != -1)
								{
									if (pos == 1)
									{
										if (Seek(cport->currentdir->fh_replys, item->first_reply, OFFSET_BEGINNING) != -1)
											if (Read(cport->currentdir->fh_replys, reply, sizeof(ReplyEntry)) == sizeof(ReplyEntry))
												pos++;
									}
									else
									{
										if (reply->next_reply != -1)
											if (Seek(cport->currentdir->fh_replys, reply->next_reply, OFFSET_BEGINNING) != -1)
												if (Read(cport->currentdir->fh_replys, reply, sizeof(ReplyEntry)) == sizeof(ReplyEntry))
													pos++;
									}
									readnew=TRUE;
								}
								else
									quit = TRUE;
							}
						}
						else
						{
							nostdcmd = TRUE;
							switch(cmdid)
							{
								case CMD_QUIT: case CMD_PARRENT:
									quit=TRUE;
									nostdcmd=FALSE;
									break;
								case CMD_REPLY:
									ioprintf("reply\n");
									nostdcmd=FALSE;
									break;
							}
							if (nostdcmd)
								quit = TRUE;
						}
					}
				}
				FreeVec(reply);
			}
			FreeVec(item);
		}
	}
}

LONG __saveds ASM nslib_editflags(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = FALSE;
	if (cport->currentdir)
	{
		BOOL		founded	= FALSE;
		ULONG 	IDNumber	= 0;
		struct	ItemEntryBlock *ieb;
		if ((ieb = nfs_support_get_ieb(name, cport)))
		{
			BPTR fh;
			char *path;
			char *fullpath = cport->currentdir->iib.fullpath;
			ULONG length_fp = strlen(fullpath);

			switch (ieb->ItemType)
			{
				case ITEMTYPE_SUBBOARD:
					if ((path = AllocVec(length_fp + strlen(name) + 20, MEMF_ANY | MEMF_CLEAR)))
					{
						if (!cport->currentdir->fh_dirs)
						{
							if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
								sprintf(path,"%s.dirs",fullpath);
							else
								sprintf(path,"%s/.dirs",fullpath);
							if (!(cport->currentdir->fh_dirs = Open(path, MODE_READWRITE)))
								result = IoErr();
						}
						if (cport->currentdir->fh_dirs)
						{
							ULONG entrys;
							founded = FALSE;
							Seek(cport->currentdir->fh_dirs, 0, OFFSET_END);
							entrys = Seek(cport->currentdir->fh_dirs, 0, OFFSET_BEGINNING) / sizeof(Directory);
							if (entrys)
							{
								struct Directory *dir;
								if ((dir = AllocVec(sizeof(Directory), MEMF_ANY)))
								{
									while (!founded && Read(cport->currentdir->fh_dirs, dir, sizeof(Directory)) == sizeof(Directory))
									{
										if (dir->iib.IPNumber == ieb->IPNumber && dir->iib.IPNumber64 == ieb->IPNumber64)
										{
											founded = TRUE;
										}
									}
									FreeVec(dir);
								}
							}
							else
								result = ERROR_OBJECT_NOT_FOUND;
						}
						FreeVec(path);
					}
					else
						result = ERROR_OUT_OF_MEMORY;
					break;
				case ITEMTYPE_COMMAND:
					result = execute_nsl("novia:scripts/edit_commandentry.nsl");
					break;
				result = ERROR_INVALID_OBJECT_TYPE;
			}
		}
		else
			result = ERROR_OUT_OF_MEMORY;
	}
	return(result);
}

LONG __saveds ASM nslib_info(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = FALSE;
	if (cport->currentdir)
	{
		BOOL		founded	= FALSE;
		ULONG 	IDNumber	= 0;
		struct ItemEntryBlock *ieb = (ItemEntryBlock *)cport->itementrylist.lh_Head;
		if (ieb->ln_Succ && ieb->ln_Pred)
		{
			StrToLong(name,(LONG *)&IDNumber);
			if (IDNumber)
			{
				while (!founded && ieb->ln_Succ)
				{
					if (ieb->IDNumber == IDNumber)
						founded = TRUE;
					else
						ieb = ieb->ln_Succ;
				}
			}
			else
			{
				while (!founded && ieb->ln_Succ)
				{
					if (ieb->Title)
					{
						if (!Stricmp(ieb->Title,name))
							founded = TRUE;
						else
							ieb = ieb->ln_Succ;
					}
					else
						ieb = ieb->ln_Succ;
				}
			}
		}
		if (founded)
		{
			BPTR fh;
			char *path;
			switch (ieb->ItemType)
			{
				case ITEMTYPE_SUBBOARD:
					if ((path = AllocVec(strlen(cport->currentdir->iib.fullpath)+strlen(name)+30,MEMF_ANY)))
					{
						if (cport->currentdir->fh_dirs)
							Seek(cport->currentdir->fh_dirs, 0, OFFSET_BEGINNING);
						else
						{
							sprintf(path,"%s/.dirs",cport->currentdir->iib.fullpath);
							cport->currentdir->fh_dirs = Open(path,MODE_READWRITE);
						}
						if (cport->currentdir->fh_dirs)
						{
							ULONG entrys, counter;
							founded = FALSE;
							Seek(cport->currentdir->fh_dirs, 0, OFFSET_END);
							entrys = Seek(cport->currentdir->fh_dirs, 0, OFFSET_BEGINNING) / sizeof(Directory);
							if (entrys)
							{
								struct Directory *dir;
								if ((dir = AllocVec(sizeof(Directory), MEMF_ANY)))
								{
									for (counter = 0; (counter < entrys && !founded); counter++)
									{
										if (Read(cport->currentdir->fh_dirs, dir, sizeof(Directory)) == sizeof(Directory))
										{
											if (dir->iib.IPNumber == ieb->IPNumber && dir->iib.IPNumber64 == ieb->IPNumber64)
											{
												founded = TRUE;
											}
										}
									}
									FreeVec(dir);
								}
							}
						}
						FreeVec(path);
					}
					break;
				case ITEMTYPE_MESSAGE:
					if ((path = AllocVec(strlen(cport->currentdir->iib.fullpath)+strlen(name)+30,MEMF_ANY)))
					{
						if (cport->currentdir->fh_files)
							Seek(cport->currentdir->fh_files, 0, OFFSET_BEGINNING);
						else
						{
							sprintf(path,"%s/.files",cport->currentdir->iib.fullpath);
							cport->currentdir->fh_files = Open(path,MODE_READWRITE);
						}
						if (cport->currentdir->fh_files)
						{
							ULONG entrys, counter;
							struct ItemEntry *itementry;
							founded = FALSE;
							Seek(cport->currentdir->fh_files, 0, OFFSET_END);
							entrys = Seek(cport->currentdir->fh_files, 0, OFFSET_BEGINNING) / sizeof(ItemEntry);
							if (entrys)
							{
								struct ItemEntry *itementry;
								if ((itementry = AllocVec(sizeof(ItemEntry), MEMF_ANY)))
								{
									for (counter = 0; (counter < entrys && !founded); counter++)
									{
										if (Read(cport->currentdir->fh_files, itementry, sizeof(ItemEntry)) == sizeof(ItemEntry))
										{
											if (itementry->iib.IPNumber == ieb->IPNumber && itementry->iib.IPNumber64 == ieb->IPNumber64)
											{
												founded = TRUE;
											}
										}
									}
									FreeVec(itementry);
								}
							}
						}
						FreeVec(path);
					}
			}
		}
	}
	return result;
}


struct NoviaDosProcess{
	char *name;
	char *filename;
	struct PortData *cport;
	struct Task     *dostask;
	struct Task		 *rttask;
	struct Task		 *client_task;
	char isrunning;
	char canclose;
};



LONG __saveds ASM nslib_execute(register __a0 char *name)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = NULL;
	if (cport)
	{
		struct Task *subtask;
		struct NoviaDosProcess *ndp;
		struct TagItem NewProcTagList[] =
		{
			{	NP_Entry,		(ULONG)execute_novia_dos_program},
			{	NP_Name,			(ULONG)name},
			{	NP_StackSize,	20000},
			{	TAG_DONE,		TAG_DONE},
		};
		if ((ndp = AllocVec(sizeof(NoviaDosProcess), MEMF_ANY | MEMF_CLEAR)))
		{
			LONG timeout		= 0;
			char *ptr = name;
			while (*ptr && *ptr != '/' && *ptr != ':')
				ptr++;
			if (*ptr == '/' | *ptr == ':')
			{
				ndp->filename = name;
			}
			else
			{
				struct ItemEntryBlock *ieb;
				if ((ieb = nfs_support_get_ieb(name, cport)))
				{
					if (ieb->ItemType == ITEMTYPE_COMMAND)
					{
						if (!cport->currentdir->fh_files)
						{
							char *readbuffer;
							char *fullpath = cport->currentdir->iib.fullpath;
							ULONG length_fp = strlen(fullpath);
							if ((readbuffer = AllocVec(length_fp + strlen(name) + 10, MEMF_ANY | MEMF_CLEAR)))
							{
								if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
									sprintf(readbuffer,"%s%s",fullpath,name);
								else
									sprintf(readbuffer,"%s/%s",fullpath,name);
								sprintf(readbuffer,"%s/.files",fullpath);
								cport->currentdir->fh_files = Open(readbuffer,MODE_READWRITE);
								FreeVec(readbuffer);
							}
						}
						if (cport->currentdir->fh_files)
						{
							struct CommandEntry *commandentry;
							BOOL founded = FALSE;
							if ((commandentry = AllocVec(sizeof(CommandEntry), MEMF_ANY)))
							{
								Seek(cport->currentdir->fh_files, 0, OFFSET_BEGINNING);
								while (!founded && Read(cport->currentdir->fh_files, commandentry, sizeof(CommandEntry)) == sizeof(CommandEntry))
								{
									if (commandentry->iib.IPNumber == ieb->IPNumber)
										founded = TRUE;
								}
								FreeVec(commandentry);
							}
							else
							{
								ioprintf("can't execute %s, out of memory.\n");
								result = ERROR_OUT_OF_MEMORY;
							}							
							if (founded)
							{
								if (commandentry->internal)
								{
									if (!StdCommand(commandentry->CommandID))
									{
										ioprintf("can't execute %s\n");
									}
									else
										ioprintf("executed %s\n");										
								}
								else
								{
									char *fullpath = cport->currentdir->iib.fullpath;
									ULONG length_fp = strlen(fullpath);
									if ((ndp->filename = AllocVec(length_fp + strlen(name) + 10, MEMF_ANY|MEMF_CLEAR)))
									{
										if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
											sprintf(ndp->filename,"%s%s",fullpath,name);
										else
											sprintf(ndp->filename,"%s/%s",fullpath,name);
									}
									else
									{
										ioprintf("can't execute %s, out of memory.\n");
										result = ERROR_OUT_OF_MEMORY;
									}
								}
							}
							else
							{
								ioprintf("%s: unknown command\n",name);
								result = ERROR_OBJECT_NOT_FOUND;
							}
						}
						else
						{
							ioprintf("can't open %s\n",name);
							result = ERROR_DIR_NOT_FOUND;
						}
					}
					else
					{
						ioprintf("invalid object type %s\n",name);
						result = ERROR_INVALID_OBJECT_TYPE;
					}
				}
				else
				{
					if (!IsListEmpty((List *)&cport->cmddir->entrylist))
					{
						BOOL founded = FALSE;
						struct CommandEntry *commandentry = (struct CommandEntry *)cport->cmddir->entrylist.mlh_Head;
						while (!founded && commandentry->iib.ln_Succ)
						{
							if (!Stricmp(commandentry->iib.Title, name))
								founded = TRUE;
							else
								commandentry = (struct CommandEntry *)commandentry->iib.ln_Succ;
						}
						if (founded)
						{
							char *fullpath = cport->cmddir->iib.fullpath;
							ULONG length_fp = strlen(fullpath);
							if ((ndp->filename = AllocVec(length_fp + strlen(name) + 10, MEMF_ANY|MEMF_CLEAR)))
							{
								if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
									sprintf(ndp->filename,"%s%s",fullpath,name);
								else
									sprintf(ndp->filename,"%s/%s",fullpath,name);
							}
							else
							{
								result = ERROR_OUT_OF_MEMORY;
								ioprintf("can't execute %s, out of memory.\n");
							}
						}
						else
						{
							ioprintf("%s: unknown command\n",name);
							result = ERROR_OBJECT_NOT_FOUND;
						}
					}
					else
					{
						ioprintf("%s: unknown command\n",name);
						result = ERROR_OBJECT_NOT_FOUND;
					}
				}
			}

			ndp->name			= name;
			ndp->cport			= cport;
			ndp->isrunning 	= FALSE;
			ndp->canclose		= FALSE;
			ndp->client_task	= FindTask(NULL);

			if (ndp->filename)
			{
				Forbid();

				if ((subtask = (struct Task *)CreateNewProc(NewProcTagList)))
					subtask->tc_UserData = ndp;

				Permit();
				while (timeout < 50 && !ndp->isrunning)
				{
					timeout++;
					Delay(1);
				}
				if (timeout < 50)
				{
					while (ndp->isrunning)
						Delay(1);
					ndp->canclose = TRUE;
				}
				else
				{
					ioprintf("timeout\n");
					ndp->canclose = TRUE;
				}
			}
		}
		else
		{
			result = ERROR_OUT_OF_MEMORY;
			ioprintf("out of memory\n");
		}
	}
	else
	{
		result = ERROR_NOT_A_NOVIA_DOS_PROGRAMM;
		ioprintf("can't find cport structure\n");
	}
	return(result);
}


void execute_novia_dos_program()
{
	struct Task * subtask			= FindTask(NULL);
	struct NoviaDosProcess *ndp	= (struct NoviaDosProcess *)subtask->tc_UserData;
	struct PortData *cport;

	if (ndp)
	{
		ndp->isrunning = TRUE;
		if (rt_semaphore)
		{
			int timeout = 0;
			while (rt_semaphore->ss_Owner && timeout < 50)
			{
				timeout++;
				Delay(1);
			}
	
			Forbid();
	
			if (timeout < 50 && !rt_semaphore->ss_Owner)
			{
				AttemptSemaphore(rt_semaphore);
				Permit();
				Execute(ndp->filename, 0, 0);
				if (rt_semaphore->ss_Owner)
					ReleaseSemaphore(rt_semaphore);

				cport = ndp->cport;
				if (cport->ConPort)
					cport->ConPort->mp_SigTask 	= ndp->client_task;
				if (cport->LocalPort)
					cport->LocalPort->mp_SigTask	= ndp->client_task;
				if (cport->rexxport)
					cport->rexxport->mp_SigTask	= ndp->client_task;
				if (cport->TimePort)
					cport->TimePort->mp_SigTask	= ndp->client_task;
				if (cport->rtport)
					cport->rtport->mp_SigTask		= ndp->client_task;
				if (cport->nfs_port)
					cport->nfs_port->mp_SigTask	= ndp->client_task;
			}
			else
			{
				printf("timeout: <%s>\n",ndp->filename);
				Permit();
				printf("system crashed ???. can't attempt rt_semaphore exclusive.\n");
			}
		}
		else
			ioprintf("can't find rt_semaphore.\n");
		ndp->isrunning = FALSE;
		while (!ndp->canclose)
			Delay(1);
		FreeVec(ndp);
	}
	else
		printf("novia task error: %x\n",ndp);
	
}

void AddLocalDir(struct Directory *dirtoadd, struct PortData *cport)
{
	char buffer[100];
	BPTR fh = NULL;
	struct Directory *dir;
	sprintf(buffer,"%s%d/.localdir",cport->sysdirs->userdir,cport->LocalUser.IDNumber);
	{
		if ((fh = Open(buffer,MODE_READWRITE)))
		{
			if ((dir = AllocVec(sizeof(Directory),MEMF_ANY|MEMF_CLEAR)))
			{
				if (Read(fh, dir, sizeof(Directory)) != sizeof(Directory))
				{
					if (Seek(fh, 0, OFFSET_BEGINNING) != -1)
					{
						strncpy(dir->iib.Title,"local",sizeof(dir->iib.Title)-1);						// copy subdir name into title
						dir->iib.ItemType = ITEMTYPE_SUBBOARD;													// set ItemType
						SetIPCounter64(&dir->iib.IPNumber64);

						GetTime(&dir->iib.LastChange);															// Get actual systemtime.
						CopyMemQuick(&dir->iib.LastChange, &dir->iib.CreateDate, sizeof(Date));		// 'nd copy date to createtime

						if ((dir->iib.fullpath = AllocVec(strlen(buffer)+20,MEMF_ANY|MEMF_CLEAR))) //
							sprintf(dir->iib.fullpath,"%s%d",cport->sysdirs->userdir,cport->LocalUser.IDNumber);

						dir->fh_messages	= NULL;
						dir->fh_files		= NULL;
						dir->fh_dirs		= NULL;
						dir->fh_text		= NULL;
						dir->fh_replys		= NULL;

						NewList((List *)&dir->iib.OpenList);
						NewList((List *)&dir->subdirlist);

						dir->localdir = TRUE;

						Write(fh, dir, sizeof(Directory));
						printf("dirtoadd: %s\n",dirtoadd->iib.fullpath);
						AddTail((List *)&dirtoadd->subdirlist,(Node *)dir);
					}
				}
				else
				{
					if ((dir->iib.fullpath = AllocVec(strlen(cport->sysdirs->userdir)+50,MEMF_ANY|MEMF_CLEAR))) //
						sprintf(dir->iib.fullpath,"%s%d",cport->sysdirs->userdir,cport->LocalUser.IDNumber);

					dir->fh_messages	= NULL;
					dir->fh_files		= NULL;
					dir->fh_dirs		= NULL;
					dir->fh_text		= NULL;
					dir->fh_replys		= NULL;

					NewList((List *)&dir->iib.OpenList);
					NewList((List *)&dir->subdirlist);

					dir->localdir = TRUE;
					AddTail((List *)&dirtoadd->subdirlist,(Node *)dir);

				}
//				FreeVec(dir);
			}
			Close(fh);
		}
	}
}

LONG __saveds ASM nslib_load_ndos_object(register __a0 char *name, register __a1 APTR ptr)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = FALSE;
	if (cport->currentdir)
	{
		BOOL		founded	= FALSE;
		ULONG 	IDNumber	= 0;
		struct	ItemEntryBlock *ieb;
		if ((ieb = nfs_support_get_ieb(name, cport)))
		{
			BPTR	fh;
			char	*path;
			char	*fullpath		= cport->currentdir->iib.fullpath;
			ULONG length_fp	= strlen(fullpath);
			ULONG Object_size	= 0;
			BPTR	Object_fh	= 0;
			struct ItemInfoBlock *iib;

			if (iib)
			{
				switch (ieb->ItemType)
				{
					case ITEMTYPE_SUBBOARD:
						Object_size = sizeof(Directory);
						Object_fh	= cport->currentdir->fh_dirs;
						break;
					case ITEMTYPE_COMMAND: case ITEMTYPE_FILEARCHIV:
						Object_size = sizeof(CommandEntry);
						Object_fh	= cport->currentdir->fh_files;
						break;
				}
				if ((path = AllocVec(length_fp + 20, MEMF_ANY | MEMF_CLEAR)))
				{
					if (!Object_fh)
					{
						switch (ieb->ItemType)
						{
							case ITEMTYPE_SUBBOARD:
								if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
									sprintf(path,"%s.dirs",fullpath);
								else
									sprintf(path,"%s/.dirs",fullpath);
								cport->currentdir->fh_dirs = Open(path, MODE_READWRITE);
								Object_fh = cport->currentdir->fh_dirs;
								break;

							case ITEMTYPE_COMMAND: case ITEMTYPE_FILEARCHIV:
								if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
									sprintf(path,"%s.files",fullpath);
								else
									sprintf(path,"%s/.files",fullpath);
								cport->currentdir->fh_files = Open(path, MODE_READWRITE);
								Object_fh = cport->currentdir->fh_files;
								break;
						}
					}
					if (Object_fh && Object_size)
					{
						ULONG entrys;
						founded = FALSE;
						Seek(Object_fh, 0, OFFSET_END);
						entrys = Seek(Object_fh, 0, OFFSET_BEGINNING) / sizeof(Directory);
						iib = (ItemInfoBlock *)ptr;
						if (entrys)
						{
							while (!founded && Read(Object_fh, ptr, Object_size) == Object_size)
							{
								if (iib->IPNumber == ieb->IPNumber && iib->IPNumber64 == ieb->IPNumber64)
									founded = TRUE;
							}
							if (!founded)
								result = ERROR_OBJECT_NOT_FOUND;
						}
						else
							result = ERROR_OBJECT_NOT_FOUND;
					}
					else
						result = ERROR_OBJECT_NOT_FOUND;
					FreeVec(path);
				}
				else
					result = ERROR_OUT_OF_MEMORY;
			}
			else
				result = ERROR_INVALID_OBJECT_TYPE;
		}
		else
			result = ERROR_OUT_OF_MEMORY;
	}
	return(result);
}

LONG __saveds ASM nslib_save_ndos_object(register __a0 char *name, register __a1 APTR ptr)
{
	struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
	LONG result = FALSE;
	if (cport && cport->currentdir)
	{
		BOOL		founded	= FALSE;
		ULONG 	IDNumber	= 0;
		struct	ItemEntryBlock *ieb;
		if ((ieb = nfs_support_get_ieb(name, cport)))
		{
			BPTR	fh;
			char	*path;
			char	*fullpath		= cport->currentdir->iib.fullpath;
			ULONG length_fp	= strlen(fullpath);
			ULONG Object_size	= 0;
			BPTR	Object_fh	= 0;
			struct ItemInfoBlock *iib;
			APTR	object;

			if (iib)
			{
				switch (ieb->ItemType)
				{
					case ITEMTYPE_SUBBOARD:
						Object_size = sizeof(Directory);
						Object_fh	= cport->currentdir->fh_dirs;
						break;
					case ITEMTYPE_COMMAND: case ITEMTYPE_FILEARCHIV:
						Object_size = sizeof(CommandEntry);
						Object_fh	= cport->currentdir->fh_files;
						break;
				}
				if ((object = AllocVec(Object_size, MEMF_ANY)))
				{
					if ((path = AllocVec(length_fp + 20, MEMF_ANY | MEMF_CLEAR)))
					{
						if (!Object_fh)
						{
							switch (ieb->ItemType)
							{
								case ITEMTYPE_SUBBOARD:
									if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
										sprintf(path,"%s.dirs",fullpath);
									else
										sprintf(path,"%s/.dirs",fullpath);
									cport->currentdir->fh_dirs = Open(path, MODE_READWRITE);
									Object_fh = cport->currentdir->fh_dirs;
									break;
	
								case ITEMTYPE_COMMAND: case ITEMTYPE_FILEARCHIV:
									if (fullpath[length_fp - 1] == ':' | fullpath[length_fp - 1] == '/')
										sprintf(path,"%s.files",fullpath);
									else
										sprintf(path,"%s/.files",fullpath);
									cport->currentdir->fh_files = Open(path, MODE_READWRITE);
									Object_fh = cport->currentdir->fh_files;
									break;
							}
						}
						if (Object_fh && Object_size)
						{
							ULONG entrys;
							founded = FALSE;
							Seek(Object_fh, 0, OFFSET_END);
							entrys = Seek(Object_fh, 0, OFFSET_BEGINNING) / sizeof(Directory);
							iib = (ItemInfoBlock *)object;
							if (entrys)
							{
								while (!founded && Read(Object_fh, iib, Object_size) == Object_size)
								{
									if (iib->IPNumber == ieb->IPNumber && iib->IPNumber64 == ieb->IPNumber64)
									{
										founded = TRUE;
									}
								}
								if (!founded)
									result = ERROR_OBJECT_NOT_FOUND;
								else
								{
									printf("founded object: %s\n",iib->Title);
									printf("ptr:            %s\n",((ItemInfoBlock *)ptr)->Title);
									if (Seek(Object_fh, - Object_size, OFFSET_CURRENT) != -1)
									{
										if (Write(Object_fh, ptr, Object_size) != Object_size)
											result = IoErr();
									}
									else
										result = IoErr();
								}
							}
							else
								result = ERROR_OBJECT_NOT_FOUND;
						}
						else
							result = ERROR_OBJECT_NOT_FOUND;
						FreeVec(path);
					}
					else
						result = ERROR_OUT_OF_MEMORY;
				}
				else
					result = ERROR_OUT_OF_MEMORY;
			}
			else
				result = ERROR_INVALID_OBJECT_TYPE;
		}
		else
			result = ERROR_OUT_OF_MEMORY;
	}
	else
		result = ERROR_NOT_A_NOVIA_DOS_PROGRAMM;
	return(result);
}
