#include <novia/novia_global.h>
#include <novia/novia_funcs.h>
#include <pragma/noviasys_lib.h>

struct DisplayNode {
    struct DimensionInfo dn_Dimensioninfo;
	char Name[32];
};

/* *** PRIVATE PROTOTYPES     *** */

void BuildVDEScreen(VDE_Menu *menu, char *structure);
void WriteVDEItem( VDE_Item *item,  char *structure,  char width);
void ME_WriteUser(ULONG UserID);


/*************************/


BOOL VDE(char vdeid,char *offsetpt)
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		char returncode;
		UBYTE ubyte, *bytept;
		UWORD uword, *wordpt;
		ULONG ulong, *longpt;
		char buffer[200], buffer2[200], *helppt;
		struct VDE_Head VDE_Head;
		struct VDE_Menu	*start_Menu;
		struct VDE_Item	*start_Item, *old_Item;
		UWORD counter,counter2,Menu=1,Item=1;
		UWORD counter3=0,counter4=0;
		char width=40;
		BOOL Quit=FALSE,rebuild=TRUE,Quit2;
		BPTR mulder;
		DisplayInfoHandle *dih;
		sprintf(buffer,"%svde/",cport->sysdirs->sysdata);
		switch (vdeid)
		{
			case VDEID_USER:
				strcat(buffer,"useredit.vde");
				break;
			case VDEID_SUBBOARD:
				strcat(buffer,"subboardedit.vde");
				break;
			case VDEID_SUBDIR:
				strcat(buffer,"subdiredit.vde");
				break;
			case VDEID_MAINPORTCONFIG:
				strcat(buffer,"MainPortConfig.vde");
				break;
			case VDEID_CLIENTCONFIG:
				strcat(buffer,"ClientConfig.vde");
				break;
			case VDEID_NRC:
				strcat(buffer,"nrc.vde");
				break;
			case VDEID_MEMBER:
				break;
		}
#ifdef DEBUG
		printf("path:%s\n",buffer);
#endif
		mulder=Open(buffer,MODE_OLDFILE);
		if (mulder==NULL)
		{
			ioprintf("can't open %s.\n",buffer);
			return FALSE;
		}
		FRead(mulder,&VDE_Head.MenuEntrys,2,1);
		FRead(mulder,&VDE_Head.ItemEntrys,2,1);
		if (VDE_Head.MenuEntrys && VDE_Head.ItemEntrys)
		{
			VDE_Head.first_Menu=
			(VDE_Menu *)AllocVec(VDE_Head.MenuEntrys*sizeof(VDE_Menu),MEMF_ANY|MEMF_CLEAR);
			if (!VDE_Head.first_Menu)
			{
				Close(mulder);
				ErrorMessage("Can't alloc mem for VDEMenu structure");
				return FALSE;
			}
			VDE_Head.last_Menu=VDE_Head.first_Menu+(VDE_Head.MenuEntrys-1);
			start_Item=
			(VDE_Item *)AllocVec(1+VDE_Head.ItemEntrys*sizeof(VDE_Item),MEMF_ANY|MEMF_CLEAR);
			start_Menu=VDE_Head.first_Menu;
			if (start_Menu==0)
			{
				Close(mulder);
				ErrorMessage("Can't alloc mem for VDEItem structure");
				return FALSE;
			}
			for (counter=0;counter<VDE_Head.MenuEntrys;counter++)
			{
				start_Menu->vde_Succ=start_Menu+1;
				start_Menu->vde_Pred=start_Menu-1;
			}
			VDE_Head.first_Menu->vde_Pred=0;
			VDE_Head.last_Menu->vde_Succ=0;
			start_Menu=VDE_Head.first_Menu;
			for (counter=0;counter<VDE_Head.MenuEntrys;counter++)
			{
				FRead(mulder,&start_Menu->MenuNumber,2,1);
				FRead(mulder,&start_Menu->VDE_Items,2,1);
				FRead(mulder,&start_Menu->Spalten,2,1);
				start_Menu->first_Item=start_Item;
				start_Menu->last_Item=start_Item+(start_Menu->VDE_Items-1);
				for (counter2=0;(counter2<start_Menu->VDE_Items && counter4<VDE_Head.ItemEntrys);counter2++)
				{
					start_Item->vde_Succ=start_Item+1;
					start_Item->vde_Pred=start_Item-1;
					FRead(mulder,&start_Item->ItemNumber,44,1);
					start_Item++;
					counter4++
				}
				start_Menu->first_Item->vde_Pred=0;
				start_Menu->last_Item->vde_Succ=0;
				start_Menu++;
			}
		}
		Seek(mulder,0,OFFSET_CURRENT);
		ulong=(long)Seek(mulder,0,OFFSET_CURRENT);
		Close(mulder);
		Quit=FALSE;
		while (!Quit && !cport->ProgramClose && cport->network.online)
		{
			if (rebuild==TRUE)
			{
				start_Menu=VDE_Head.first_Menu;
				while(start_Menu->MenuNumber!=Menu)
				{
					start_Menu++;
				};
				if (start_Menu!=0)
					{
						width=40;
						if (start_Menu->Spalten==3)width=26;
						BuildVDEScreen(start_Menu,offsetpt);
						start_Item=start_Menu->first_Item;
					}
				else
					{return FALSE;}
				rebuild=FALSE;
			}
			if (start_Item->Item_Type2==VDE_SAVE)
			{
				Writeio("[47m[32m",-1);
			}
			else
			{
				if (start_Item->Item_Type2==VDE_QUIT)
				{
					Writeio("[47m[31m",-1);
				}
				else
				{
					Writeio("[47m[34m",-1);
				}
			}
			JumpXY(((start_Item->X-1)*width)+1,start_Item->Y);
			Writeio(start_Item->ItemName,-1);
			Conread(buffer,1,0);
			switch (*buffer)
			{
				case 13:
					switch (start_Item->Item_Type2)
					{
						case VDE_SUBMENU:
							Menu=(UWORD)start_Item->Fieldlen;
							rebuild=TRUE;
							break;
						case VDE_QUIT:
							Quit=TRUE;
							returncode=FALSE;
							break;
						case VDE_SAVE:
							Quit=TRUE;
							returncode=TRUE;
							break;
						case VDE_EDITMEMBERS:
							VDEEditMemberList((List *)(offsetpt+start_Item->Offset));
							rebuild=TRUE;
							break;
						case VDE_READWRITE:
							switch (start_Item->Item_Type1)
							{
								case VDE_STRING:
									Writeio("[40m[33m ",-1);
									Getstring(buffer,offsetpt+start_Item->Offset,start_Item->Fieldlen,0,0);
									if (strlen(buffer)>=start_Item->min)
										strcpy(offsetpt+start_Item->Offset,buffer);
									else
										WriteVDEItem(start_Item,offsetpt, width);
									break;
								case VDE_BOOL:
									helppt=(char *)offsetpt+start_Item->Offset;
									if (*helppt==TRUE)
										*helppt=FALSE;
									else
										*helppt=TRUE;
									WriteVDEItem(start_Item,offsetpt,width);
									break;
								case VDE_BYTE:
									Writeio("[40m[33m ",-1);
									Getbyte(&ubyte,(UBYTE *)offsetpt+(start_Item->Offset),start_Item->Fieldlen,0,0);
									if (ubyte>=start_Item->min && ubyte<=start_Item->max)
									{
										bytept=(UBYTE *)offsetpt+start_Item->Offset;
										*bytept=ubyte;
									}
									break;
								case VDE_WORD:
									Writeio("[40m[33m ",-1);
									Getword(&uword,(UWORD *)offsetpt+(start_Item->Offset>>1),start_Item->Fieldlen,0,0);
									if (uword>=start_Item->min && uword<=start_Item->max)
									{
										wordpt=(UWORD *)offsetpt+(start_Item->Offset>>1);
										*wordpt=uword;
									}
									break;
								case VDE_LONG:
									Writeio("[40m[33m ",-1);
									Getlong(&ulong,(ULONG *)offsetpt+(start_Item->Offset>>2),start_Item->Fieldlen,0,0);
									if (ulong>=start_Item->min && ulong<=start_Item->max)
									{
										longpt=(ULONG *)offsetpt+(start_Item->Offset>>2);
										*longpt=ulong;
									}
									break;
								case VDE_SCREENMODE:
									longpt=(ULONG *)offsetpt+(start_Item->Offset>>2);
									if ((ulong=ScreenModeReq(*longpt))!=INVALID_ID)
									{
										*longpt=ulong;
									}
									rebuild=TRUE;
									break;
								case VDE_IP:
									IPToStr(buffer2,(ULONG)*((ULONG *)offsetpt+(start_Item->Offset>>2)));
									Writeio("[40m[33m ",-1);
									Getstring(buffer,buffer2,15,0,0);
									if (strlen(buffer))
									{
										longpt=(ULONG *)offsetpt+(start_Item->Offset>>2);
										*longpt=StrToIP(buffer);
									}
									break;
								case VDE_GENDER:
									if (*(offsetpt+start_Item->Offset))
										*(offsetpt+start_Item->Offset)=0;
									else
										*(offsetpt+start_Item->Offset)=1;
									break;
								case VDE_NETWORK:
								case VDE_BUFFERTYPE:
								case VDE_SEX:
								case VDE_LANGUAGE:
								case VDE_TEXTTYPE:
								case VDE_MOREMODE:
								case VDE_TIMEFORMAT:
								case VDE_DATEFORMAT:
								case VDE_TERMLINEFEED:
								case VDE_TERMTABS:
								case VDE_TERMANSI:
								case VDE_TERMCOLOR:
								case VDE_TERMTYPE:
								case VDE_COMPTYPE:
								case VDE_HELPLEVEL:
								case VDE_PROTOCOL:
								case VDE_PAUSING:
								case VDE_YANKHIDE:
								case VDE_AUTOHIDE:
									if ((UWORD)start_Item->Item_Type1<cport->strgroups)
									{
										if (*(offsetpt+start_Item->Offset)<cport->strgroup[start_Item->Item_Type1].maxid-1)
											(*(offsetpt+start_Item->Offset))++;
										else
											*(offsetpt+start_Item->Offset)=0;
										WriteVDEItem(start_Item,offsetpt,width);
									}
									break;
								case VDE_FONT:
									break;
							}
							break;
					}
					break;
				case -101:
					Conread(buffer,1,0);
					switch(*buffer)
					{
						case 65:
							if (start_Item->Item_Type2==VDE_SAVE)
							{
								Writeio("[42m[37m",-1);
							}
							else
							{
								if (start_Item->Item_Type2==VDE_QUIT)
								{
									Writeio("[41m[37m",-1);
								}
								else
								{
									Writeio("[44m[37m",-1);
								}
							}
							JumpXY(((start_Item->X-1)*width)+1,start_Item->Y);
							Writeio(start_Item->ItemName,-1);
							if (start_Item->vde_Pred!=0)
								start_Item=start_Item->vde_Pred;
							else
								start_Item=start_Menu->last_Item;
							break;
						case 66:
							if (start_Item->Item_Type2==VDE_SAVE)
							{
								Writeio("[42m[37m",-1);
							}
							else
							{
								if (start_Item->Item_Type2==VDE_QUIT)
								{
									Writeio("[41m[37m",-1);
								}
								else
								{
									Writeio("[44m[37m",-1);
								}
							}
							JumpXY(((start_Item->X-1)*width)+1,start_Item->Y);
							Writeio(start_Item->ItemName,-1);
							if (start_Item->vde_Succ!=0)
								start_Item=start_Item->vde_Succ;
							else
								start_Item=start_Menu->first_Item;
							break;
						case 68:
							if (start_Item->X>1)
							{
								Quit2=FALSE;
								old_Item=start_Item;
								while (start_Item->vde_Pred!=0 && Quit2==FALSE)
								{
									start_Item=start_Item->vde_Pred;
									if (old_Item->Y==start_Item->Y)
									{
										if (start_Item->Item_Type2==VDE_SAVE)
										{
											Writeio("[42m[37m",-1);
										}
										else
										{
											if (start_Item->Item_Type2==VDE_QUIT)
											{
												Writeio("[41m[37m",-1);
											}
											else
											{
												Writeio("[44m[37m",-1);
											}
										}
										JumpXY(((old_Item->X-1)*width)+1,old_Item->Y);
										Writeio(old_Item->ItemName,-1);
										Quit2=TRUE;
									}
								}
								if (Quit2==FALSE)start_Item=old_Item;
							}
							break;
						case 67:
							if (start_Item->X<start_Menu->Spalten)
							{
								Quit2=FALSE;
								old_Item=start_Item;
								while (start_Item->vde_Succ!=0 && Quit2==FALSE)
								{
									start_Item=start_Item->vde_Succ;
									if (old_Item->Y==start_Item->Y)
									{
										if (start_Item->Item_Type2==VDE_SAVE)
										{
											Writeio("[42m[37m",-1);
										}
										else
										{
											if (start_Item->Item_Type2==VDE_QUIT)
											{
												Writeio("[41m[37m",-1);
											}
											else
											{
												Writeio("[44m[37m",-1);
											}
										}
										JumpXY(((old_Item->X-1)*width)+1,old_Item->Y);
										Writeio(old_Item->ItemName,-1);
										Quit2=TRUE;
									}
								}
								if (Quit2==FALSE)start_Item=old_Item;
							}
							break;
				 	}
					break;
			}
		}
		CLS();
		FreeVec(VDE_Head.first_Menu->first_Item);
		FreeVec(VDE_Head.first_Menu);
		return returncode;
	}
}


void BuildVDEScreen(VDE_Menu *menu, char *structure)
{
	char width=40;
	int counter;
	struct VDE_Item *start_Item=menu->first_Item;
	CLS();
	if (menu->Spalten==3)width=26;
	for (counter=0;counter<menu->VDE_Items;counter++)
	{
		WriteVDEItem(start_Item,structure,width);
		start_Item=start_Item->vde_Succ;
	}
}


void WriteVDEItem( VDE_Item *item,  char *structure,  char width)
{
	UBYTE ubyte;
	UWORD uword;
	ULONG ulong;
	char *helppt;
	char buffer[50];
	Date *xdate;
	NameInfo *nameinfo;
	JumpXY(((item->X-1)*width)+1,item->Y);
	if (item->Item_Type2==VDE_SAVE)
	{
		Writeio("[42m[37m",-1);
	}
	else
	{
		if (item->Item_Type2==VDE_QUIT)
		{
			Writeio("[41m[37m",-1);
		}
		else
		{
			Writeio("[44m[37m",-1);
		}
	}
	Writeio(item->ItemName,-1);
	Writeio("[40m[33m ",-1);
	switch (item->Item_Type1)
	{
		case VDE_BYTE:
			ubyte=(UBYTE)*(structure+item->Offset);
			Writelong((ULONG)ubyte);
			break;
		case VDE_WORD:
			uword=(UWORD)*((UWORD *)structure+(item->Offset>>1));
			Writelong((ULONG)uword);
			break;
		case VDE_LONG:
			ulong=(ULONG)*((ULONG *)structure+(item->Offset>>2));
			Writelong(ulong);
			break;
		case VDE_IP:
			IPToStr(buffer,(ULONG)*((ULONG *)structure+(item->Offset>>2)));
			Writeio(buffer,-1);
			break;
		case VDE_BOOL:
			helppt=structure+item->Offset;
			if (*helppt==TRUE)
				Writeio("Yes",-1);
			else
				Writeio("No ",-1);
			break;
		case VDE_STRING:
			Writeio(structure+item->Offset,item->Fieldlen);
			break;
		case VDE_DATE:
			xdate=(Date *)((UBYTE *)structure+item->Offset);
			ioprintf("%02d-%02d-%02d %02d:%02d:%02d",xdate->day,xdate->month,xdate->year,xdate->hours,xdate->mins,xdate->secs);
			break;
		case VDE_SCREENMODE:
			if ((nameinfo=AllocVec(sizeof(NameInfo),MEMF_ANY)))
			{
				ulong=(ULONG)*((ULONG *)structure+(item->Offset>>2));
#ifdef DEBUG
				printf("screenmodeid: %d",ulong);
#endif
				if (GetDisplayInfoData(0,(APTR)nameinfo,sizeof(NameInfo),DTAG_NAME,ulong))
				{
					Writeio(nameinfo->Name,-1)
				}
				else
				{
					Writeio("unknown",-1);
				}
				FreeVec(nameinfo)
			}
			else
			{
				Writeio("no mem",-1);
			}
			break;
		case VDE_GENDER:
		case VDE_NETWORK:
		case VDE_BUFFERTYPE:
		case VDE_SEX:
		case VDE_LANGUAGE:
		case VDE_TEXTTYPE:
		case VDE_MOREMODE:
		case VDE_TIMEFORMAT:
		case VDE_DATEFORMAT:
		case VDE_TERMLINEFEED:
		case VDE_TERMTABS:
		case VDE_TERMANSI:
		case VDE_TERMCOLOR:
		case VDE_TERMTYPE:
		case VDE_COMPTYPE:
		case VDE_HELPLEVEL:
		case VDE_PROTOCOL:
		case VDE_PAUSING:
		case VDE_YANKHIDE:
		case VDE_AUTOHIDE:
		case VDE_FONT:
			ubyte=(UBYTE)*(structure+item->Offset);
			ioprintf("%-15s",getstr((UWORD)item->Item_Type1,(UWORD)ubyte));
			break;
	}
}

ULONG ScreenModeReq(ULONG OldScreenMode)
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		char listnew=TRUE;
		char quit=FALSE;
		char cp[20];
		char buffer[50];
		char pos;
		ULONG counter=0;
		ULONG idcounter=0;
	    struct DisplayNode *wnode=NULL;
	    ULONG modeID;
	    ULONG skipID;
		ULONG id=INVALID_ID;
	    ULONG result;
	    struct DisplayInfo displayinfo;
	    struct NameInfo nameinfo;
	
		CLS();
		ioprintf("c7z4 NOViA MEMBER LiST EDiTOR V1.0                                     z0\n");
		ioprintf("c7z4 [ESCape]-About, [Return]-OK, [A]-Add a Member [D]-Delete a Member z0\n");
		LF();
		
		pos=1;
		modeID = INVALID_ID;
		GetDisplayInfoData(NULL, (UBYTE *) & displayinfo,sizeof(struct DisplayInfo),DTAG_DISP, LORES_KEY);
		if (displayinfo.PropertyFlags & DIPF_IS_PAL)
		{
			skipID = PAL_MONITOR_ID;
		}
		else
		{
			skipID = NTSC_MONITOR_ID;
		}
		while ((modeID = NextDisplayInfo(modeID)) != INVALID_ID)
		{
			if ((modeID & MONITOR_ID_MASK) != skipID)
			{
				if (result = GetDisplayInfoData(NULL,(APTR)&nameinfo,sizeof(struct NameInfo),DTAG_NAME,modeID))
				{
					result = GetDisplayInfoData(NULL,(APTR)&displayinfo,sizeof(struct DisplayInfo),DTAG_DISP,modeID);
					if (result && !displayinfo.NotAvailable)
					{
						idcounter++;
					}
				}
			}
		}
		if (wnode=AllocVec(sizeof(DisplayNode)*idcounter,MEMF_ANY|MEMF_CLEAR))
		{
			counter=0;
			modeID = INVALID_ID;
			while ((modeID = NextDisplayInfo(modeID)) != INVALID_ID)
			{
				if ((modeID & MONITOR_ID_MASK) != skipID)
				{
					if (result = GetDisplayInfoData(NULL,(APTR)&nameinfo,sizeof(struct NameInfo),DTAG_NAME,modeID))
					{
						result = GetDisplayInfoData(NULL,(APTR)&displayinfo,sizeof(struct DisplayInfo),DTAG_DISP,modeID);
						if (result && !displayinfo.NotAvailable)
						{
							result = GetDisplayInfoData(NULL,(APTR)&wnode[counter].dn_Dimensioninfo,sizeof(struct DimensionInfo),DTAG_DIMS,modeID);
							if (result)
								strcpy(wnode[counter].Name,nameinfo.Name);
								counter++;
						}
					}
				}
			}
		}
		else
			quit=TRUE;
		if (!quit)
		{
			CLS();
			ioprintf("c7z4NOViA ANSI-ScreenModeRequest V1.0           z0\n");
			ioprintf("c7z4                                            z0\n");
			LF();
		}
		counter=0;
	
		while (wnode[counter].dn_Dimensioninfo.Header.DisplayID!=OldScreenMode)
			counter++;
		if (wnode[counter].dn_Dimensioninfo.Header.DisplayID!=OldScreenMode)
			counter=0;
	
		pos=1;
		while(!quit && !cport->ProgramClose && cport->network.online)
		{
			if (listnew)
			{
				ULONG i=0;
				Writeio("[4Hz0",-1);	// Jump to listbeginn.
				while (counter+i<idcounter && i<15)
				{
					ioprintf("c7%32s\n",wnode[counter+i].Name);
					i++;
				}
				counter=counter+pos-1;
				ioprintf("[%dHz4c7%32sz0",pos+3,wnode[counter].Name);
				listnew=FALSE;
			}
			Conread(cp,1,0);
			switch (*cp)
			{
				case 'S': case 's':	case 13:	// OK
					quit=TRUE;
					id=wnode[counter].dn_Dimensioninfo.Header.DisplayID;
					break;
				case 27: 						// ESCape
					quit=TRUE;
					id=INVALID_ID;
					break;
				case 'A':		// Curser up
					if (counter>0)
					{
						if (pos>1)
						{
							ioprintf("[%dHc7z0%32s[Fz4%32s",pos+3,wnode[counter].Name,wnode[counter-1].Name);
							pos--;
						}
						else
						{
							ioprintf("[%dHc7z0%32s[Fz4[18H[M[4H[L%32s",pos+3,wnode[counter].Name,wnode[counter-1].Name);
						}
						counter--;
					}
					else
					{
						if (idcounter>=15)
						{
							counter=idcounter-15;
							pos=15;
							listnew=TRUE;
						}
					}
					break;
				case 'B':		// Curser down
					if (counter<idcounter-1)
					{
						if (pos<15)
						{
							ioprintf("[%dHc7z0%32s[Ez4%32s",pos+3,wnode[counter].Name,wnode[counter+1].Name);
							pos++;
						}
						else
						{
							ioprintf("[%dHc7z0%32s[4H[M[18Hz4%32s",pos+3,wnode[counter].Name,wnode[counter+1].Name);
						}
						counter++;
					}
					else
					{
						counter=0;
						pos=1;
						listnew=TRUE;
					}
					break;
			}
		}
		if (wnode)FreeVec(wnode);
		return id;
	}
}


void VDEEditMemberList(List *mlist)
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		char listnew=TRUE;
		char quit=FALSE;
		char cp[20];
		char buffer[50];
		ULONG ulong;
		char pos;
		char result=FALSE;
		char counter=0;
		struct Member *member;
		struct Member *newmember;
		CLS();
		ioprintf("c7z4 NOViA MEMBER LiST EDiTOR V1.0                                     z0\n");
		ioprintf("c7z4 [ESCape]-About, [Return]-OK, [A]-Add a Member [D]-Delete a Member z0\n");
		LF();
		
		pos=1;
	
		member=(Member *)mlist->lh_Head;
		Writeio("[p",-1);					// Curser off
		while(!quit && !cport->ProgramClose && cport->network.online)
		{
			if (listnew)
			{
				Writeio("[4Hz0c7",-1);	// Jump to listbeginn.
				ulong=0;
				newmember=member;
				while (newmember->ln_Succ && ulong<15)
				{
					ME_WriteUser(newmember->UserID);
					LF();
					newmember=newmember->ln_Succ;
					ulong++;
				}
				for (counter=ulong; counter<15; counter++)
					Writeio("[K",-1);
				ioprintf("[4Hz4");
				ME_WriteUser(member->UserID);
				listnew=FALSE;
				pos=1;
			}
			Conread(cp,1,0);
			if (*cp=='A' |*cp=='a')
			{
				if (newmember=AllocVec(sizeof(Member),MEMF_ANY))
				{
					Writeio("[20H[Kc3z0User name: ",-1);
					Getstring(buffer,0,30,0,0);
					if (newmember->UserID=FindUser(buffer))
					{
						struct Member *mem=(Member *)mlist->lh_Head;
						BOOL alreadyexist=FALSE;
						while (mem->ln_Succ && !alreadyexist)
						{
							if (mem->UserID==newmember->UserID)
								alreadyexist=TRUE;
							mem=mem->ln_Succ;
						}
						if (!alreadyexist)
						{
							AddTail(mlist,(Node *)newmember);
							ioprintf("[20H[Kc7User %s (%d) is now a member.",
								cport->UL.utable[newmember->UserID].Handle,newmember->UserID);
							ulong=0;
							newmember=(Member *)mlist->lh_TailPred;
							while (newmember->ln_Pred->ln_Pred && ulong<14)
							{
								newmember=newmember->ln_Pred;
								ulong++;
							}
							member=newmember;
							listnew=TRUE;
						}
						else
						{
							ioprintf("[20H[Kc7User %s (%d) is already a member.",
								cport->UL.utable[newmember->UserID].Handle,newmember->UserID);
							FreeVec(newmember);
						}
					}
					else
					{
						Writeio("[20H[Kc1unknown User.",-1);
						FreeVec(newmember);
					}
				}
			}
			if (*cp=='d' | *cp=='D' | *cp==121)
			{
				if (member && member->ln_Succ && member->ln_Pred)
				{
					if (member->ln_Succ->ln_Succ)
						newmember=member->ln_Succ;
					else
						if (member->ln_Pred->ln_Pred)
							newmember=member->ln_Pred;
						else
							newmember=NULL;
					ioprintf("[20H[Kz0c7User %s (%d) removed.",
						cport->UL.utable[member->UserID].Handle,member->UserID);
					Remove((Node*)member);
					FreeVec(member);
					listnew=TRUE;
					if (newmember)
						member=newmember;
					else
						member=NULL;
				}
				else
					Writeio("[20H[Kz0c1Memberlist is empty.",-1);
	
			}
			if (*cp=='Q' |*cp=='q'|*cp==13|*cp==10)quit=TRUE;
			if (*cp==-101)						// beginning Curser Keys
			{
				Conread(cp,1,0);
				switch (*cp)
				{
					case 'A':		// Curser up
						if (member && member->ln_Pred->ln_Pred)
						{
							if (pos>1)
							{
								ioprintf("[%dHc7z0",pos+3);
								ME_WriteUser(member->UserID);
								Writeio("[Fz4",-1);
								member=member->ln_Pred;
								ME_WriteUser(member->UserID);
								pos--;
							}
							else
							{
								ioprintf("[%dHc7z0",pos+3);
								ME_WriteUser(member->UserID);
								member=member->ln_Pred;
								Writeio("[18H[M[4H[Lz4",-1);
								ME_WriteUser(member->UserID);							
							}
						}
						break;
					case 'B':		// Curser down
						if (member && member->ln_Succ->ln_Succ)
						{
							if (pos<15)
							{
								ioprintf("[%dHc7z0",pos+3);
								ME_WriteUser(member->UserID);
								Writeio("[Ez4",-1);
								member=member->ln_Succ;
								ME_WriteUser(member->UserID);
								pos++;
							}
							else
							{
								ioprintf("[%dHc7z0",pos+3);
								ME_WriteUser(member->UserID);
								Writeio("[4H[M[18Hz4",-1);
								member=member->ln_Succ;
								ME_WriteUser(member->UserID);
							}
						}
						break;
				}
			}
		}
		Writeio("[0p",-1);					// Curser on
	}
}


void ME_WriteUser(ULONG UserID)
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		if (UserID>0 && UserID<=cport->UL.UserEntrys)
			ioprintf("User: %21s (%d)[K",cport->UL.utable[UserID].Handle,UserID);
	}
}
/*
void VDEEditCommandList()
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	ioprintf("startn\n");
	if (cport)
	{
		struct command_table *cmd=cport->cmd;
		char listnew=TRUE;
		char quit=FALSE;
		char cp[20];
		char buffer[80];
		ULONG ulong;
		char pos;
		char result=FALSE;
		ULONG counter=0;
		struct int_command *icmd=NULL;
		ULONG icommands=0;
		BPTR mulder;
	
		sprintf(buffer,"%ssys.cmdlist.internal",cport->sysdirs->sysdata);
		if (mulder=Open(buffer,MODE_OLDFILE))
		{
			FRead(mulder,&icommands,4,1);
			if (icommands)
			{
				if (icmd=AllocVec(sizeof(command)*icommands,MEMF_ANY))
					FRead(mulder,icmd,sizeof(int_command)*commands,1);
			}
			Close(mulder);
		}
	
		if (!icmd) return;
	
		CLS();
		ioprintf("c7z4 NOViA COMMAND LiST EDiTOR V1.0                                    z0\n");
		ioprintf("c7z4 [ESCape]-About, [Return]-OK, [A]-Add a Member [D]-Delete a Member z0\n");
		LF();
		
		pos=1;
	
		while(!quit && !cport->ProgramClose && cport->network.online)
		{
			if (listnew)
			{
				ULONG counter2=counter;
				ulong=0;
				Writeio("[4Hz0c7",-1);	// Jump to listbeginn.
				while (counter2<cmd->entrys && ulong<15)
				{
					ioprintf("%4d %-32s %s %s[K",cmd->cmd[counter2]->id,cmd->cmd[counter2]->name,getstr(200,cmd->cmd[counter2]->type),getstr(205,cmd->cmd[counter2]->id));
					LF();
					counter2++;
					ulong++;
				}
				for (ulong=ulong; ulong<15; ulong++)
					Writeio("[K",-1);
				ioprintf("[4Hz4%4d %-32s %s %s[K",cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
				listnew=FALSE;
				pos=1;
			}
			Conread(cp,1,0);
			if (*cp=='a' | *cp=='A' && cmd->entrys<cmd->tablesize && (cmd->cmd[cmd->entrys]=AllocVec(sizeof(command),MEMF_ANY|MEMF_CLEAR)))
			{
				char fpos=1,result;
				ioprintf("[20H[Kc7z4Name:z0c3 %-32s z4c7  Comment:z0c3 %s",cmd->cmd[cmd->entrys]->name,cmd->cmd[cmd->entrys]->comment);
				ioprintf("[21H[Kc7z4Accountlevel:z0c3 %-5d z4c7CommandType:z0c3 %-5d",cmd->cmd[cmd->entrys]->accountlevel,cmd->cmd[cmd->entrys]->type);
				ioprintf("[21;40Hz4c7CommandID:z0c3 %d",cmd->cmd[cmd->entrys]->id);
				while (fpos>0 && fpos<=5)
				{
					result=0;
					switch (fpos)
					{
						case 1:
							Writeio("[20;7Hc3",-1);
							result=Getstring(buffer,cmd->cmd[cmd->entrys]->name,32,TAB,0);
							if (strlen(buffer))strncpy(cmd->cmd[cmd->entrys]->name,buffer,32);
							break;
						case 2:
							Writeio("[20;50H",-1);
							result=Getstring(buffer,cmd->cmd[cmd->entrys]->comment,32,TAB,0);
							if (strlen(buffer))strncpy(cmd->cmd[cmd->entrys]->comment,buffer,32);
							break;
						case 3:
							Writeio("[21;15H",-1);
							result=Getlong(&ulong,&cmd->cmd[cmd->entrys]->accountlevel,5,TAB,0);
							if (ulong)cmd->cmd[cmd->entrys]->accountlevel=ulong;
							break;
						case 4:
							Writeio("[21;34H",-1);
							result=Getlong(&ulong,&cmd->cmd[cmd->entrys]->type,5,TAB,0);
							if (ulong)cmd->cmd[cmd->entrys]->type=ulong;
							break;
						case 5:
							Writeio("[21;51H",-1);
							result=Getlong(&ulong,&cmd->cmd[cmd->entrys]->id,5,TAB,0);
							if (ulong)cmd->cmd[cmd->entrys]->id=ulong;
							break;
	
					}
					if (!result)
						fpos=0;
					else
					{
						if (result==TAB_FORWARD)fpos++;
						if (result==TAB_BACKWARD)fpos--;
					}
				}
				ioprintf("[20H[K[21H[K[%dHc7z4%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
				cmd->entrys++;
				SaveCommandList();
			}
			if (*cp=='e' | *cp=='E' | *cp==13 | *cp==10)
			{
				char fpos=1,result;
	
				ioprintf("[20H[Kc7z4Name:z0c3 %-32s z4c7Comment:z0c3 %s",cmd->cmd[counter]->name,cmd->cmd[counter]->comment);
				ioprintf("[21H[Kc7z4Accountlevel:z0c3 %-5d z4c7CommandType:z0c3 %-5d",cmd->cmd[counter]->accountlevel,cmd->cmd[counter]->type);
				ioprintf("[21;40Hz4c7CommandID:z0c3 %d",cmd->cmd[counter]->id);
	
				while (fpos>0 && fpos<=5)
				{
					result=0;
					switch (fpos)
					{
						case 1:
							Writeio("[20;7Hc3",-1);
							result=Getstring(buffer,cmd->cmd[counter]->name,32,TAB,0);
							if (strlen(buffer))strncpy(cmd->cmd[counter]->name,buffer,32);
							break;
						case 2:
							Writeio("[20;50H",-1);
							result=Getstring(buffer,cmd->cmd[counter]->comment,32,TAB,0);
							if (strlen(buffer))strncpy(cmd->cmd[counter]->comment,buffer,32);
							break;
						case 3:
							Writeio("[21;15H",-1);
							result=Getlong(&ulong,&cmd->cmd[counter]->accountlevel,5,TAB,0);
							if (ulong)cmd->cmd[counter]->accountlevel=ulong;
							break;
						case 4:
							Writeio("[21;34H",-1);
							result=Getlong(&ulong,&cmd->cmd[counter]->type,5,TAB,0);
							if (ulong)cmd->cmd[counter]->type=ulong;
							break;
						case 5:
							Writeio("[21;51H",-1);
							result=Getlong(&ulong,&cmd->cmd[counter]->id,5,TAB,0);
							if (ulong)cmd->cmd[counter]->id=ulong;
							break;
					}
					if (!result)
						fpos=0;
					else
					{
						if (result==TAB_FORWARD)fpos++;
						if (result==TAB_BACKWARD)fpos--;
					}
				}
				ioprintf("[20H[K[21H[K[%dHc7z4%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
			}
			if (*cp=='d' | *cp=='D')
			{
				ioprintf("[20Hc3z0Delete Entry: %s (Yes)?",cmd->cmd[counter]->name);
				if (cmd->entrys>1 && Yesno(TRUE,0))
				{
					ULONG counter2;
					ioprintf("[20H[K");
					for (counter2=counter; counter2<cmd->entrys; counter2++)
						if (cmd->cmd[counter2] && cmd->cmd[counter2+1])
							CopyMem(cmd->cmd[counter2+1],cmd->cmd[counter2],sizeof(command));
					cmd->entrys--;
					ioprintf("[20H[K[%dH[M",pos+3);
					if (counter+pos-1<cmd->entrys)
						ioprintf("[18Hz0c7%4d %-32s %s %s[K",cmd->cmd[counter+15-pos]->id,cmd->cmd[counter+15-pos]->name,getstr(200,cmd->cmd[counter+15-pos]->type),getstr(205,cmd->cmd[counter+15-pos]->id));
					else
						ioprintf("[18H[K");
					if (counter>=cmd->entrys && counter)
					{
						pos--;
						counter--;
					}
					ioprintf("[%dHz4c7z4%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
				}
			}
			if (*cp=='Q' | *cp=='q'|*cp==27)quit=TRUE;
			if (*cp==-101)						// beginning Curser Keys
			{
				Conread(cp,1,0);
				switch (*cp)
				{
					case 'A':		// Curser up
						if (counter>0)
						{
							if (pos>1)
							{
								ioprintf("[%dHc7z0%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								counter--;
								ioprintf("[Fz4%4d %-32s %s %s[K",cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								pos--;
							}
							else
							{
								ioprintf("[%dHc7z0%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								counter--;
								ioprintf("[18H[M[4H[Lz4%4d %-32s %s %s[K",cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
							}
						}
						break;
					case 'B':		// Curser down
						if (counter<cmd->entrys-1)
						{
							if (pos<15)
							{
								ioprintf("[%dHc7z0%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								counter++;
								ioprintf("[Ez4%4d %-32s %s %s[K",cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								pos++;
							}
							else
							{
								ioprintf("[%dHc7z0%4d %-32s %s %s[K",pos+3,cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
								counter++;
								ioprintf("[4H[M[18Hz4%4d %-32s %s %s[K",cmd->cmd[counter]->id,cmd->cmd[counter]->name,getstr(200,cmd->cmd[counter]->type),getstr(205,cmd->cmd[counter]->id));
							}
						}
						break;
				}
			}
		}
		SaveCommandList();
	}
}
*/
/*	char 	name[32];		// 32
	char	comment[32];	// 64
	ULONG 	id;				// 68
	ULONG	accountlevel;	// 72
	ULONG	type;			// 76
	ULONG	reserverd;		// 78*/


/*	struct STR_Group
	{
		UWORD entrys;
		char **table;
	};
*/
/*	gr->table=AllocVec(16,0);
	gr->table[0]=string1;
	gr->table[2]=string2;
	printf("s1: %s\n",gr->table[0]);
	printf("s1: %s\n",gr->table[1]);
	printf("s1: %s\n",gr->table[2]);*/

/*	if (!id)return "INVALID";
	if (id==cmd->cmd_TYPE_INTERNAL)return "INTERNAL";
	if (id==cmd->cmd_TYPE_DOS)return "DOS";
	if (id==cmd->cmd_TYPE_NOViA)return "NOVIA";
	if (id==cmd->cmd_TYPE_AREXX_NOVIA)return "NOVIA_AREXX";
	if (id==cmd->cmd_TYPE_AREXX_CNET)return "CNET_AREXX";
#define cmd->cmd_TYPE_INVALID		0
#define cmd->cmd_TYPE_INTERNAL		1
#define cmd->cmd_TYPE_DOS			1<<1
#define cmd->cmd_TYPE_NOViA			1<<2
#define cmd->cmd_TYPE_AREXX_NOVIA	1<<3
#define cmd->cmd_TYPE_AREXX_CNET		1<<4

}
*/

void SaveCommandList()
{
	struct PortData *cport=(PortData *)FindTask(NULL)->tc_UserData;
	if (cport)
	{
		BPTR mulder;
		char buffer[100];
		sprintf(buffer,"%ssys.cmdlist",cport->sysdirs->sysdata);
		if (mulder=Open(buffer,MODE_NEWFILE))
		{
			ULONG counter;
			Write(mulder,&cport->cmd->entrys,4);
			for (counter=0; counter<cport->cmd->entrys;counter++)
				Write(mulder,cport->cmd->cmd[counter],sizeof(command));
			Close(mulder);
		}
	}
}




