#include <pragma/noviasys_lib.h>
#include <pragma/exec_lib.h>
#include <stdio.h>
#include <novia/novia_portdata.h>

struct Library *NoviaSysBase;

void ioprintf(const char *string, ...)
{
	char *buffer = AllocVec(10000,MEMF_ANY|MEMF_CLEAR);
	if (buffer)
	{
		vsprintf(buffer, string, unsigned int(&string + 1));
		Writeio(buffer,-1);
		FreeVec(buffer);
	}
}

void main()
{
	if ((NoviaSysBase = OpenLibrary("noviasys.library", 0)))
	{
		struct PortData *cport = (struct PortData *)FindTask(NULL)->tc_UserData;
		ItemEntryBlock *ieb;
		if ((ieb = ndos_get_ieb(cport->argstring[1])))
		{
			switch(ieb->ItemType)
			{
				case ITEMTYPE_SUBBOARD:
					execute_nsl("novia:scripts/edit_directoryentry.nsl");
					break;
				case ITEMTYPE_MESSAGE:
					execute_nsl("novia:scripts/edit_itementry.nsl");
					break;
				case ITEMTYPE_FILEARCHIV:
					execute_nsl("novia:scripts/edit_fileentry.nsl");
					break;
				case ITEMTYPE_EMAIL:
					execute_nsl("novia:scripts/edit_emailentry.nsl");
					break;
				case ITEMTYPE_COMMAND:
					execute_nsl("novia:scripts/edit_commandentry.nsl");
					break;
			}
		}
		CloseLibrary(NoviaSysBase);
	}
}