#ifndef NOVIA_DOS_H
#define NOVIA_DOS_H
#define NOVIA_DOS_H_VERSION "$VER: 0.59 (23.10.1999)"
#define NOVIA_DOS_VER 59
// (c) Copyright 1996-1999 by Thorsten Gehler
// All rights reserved. Read license.readme for copyright informations.
// VER 0.13 (09.08.1998)
// VER 0.14 (11.08.1998)
// VER 0.15 (17.08.1998)
// VER 0.54 (27.02.1999)
// VER 0.55 (07.03.1999)
// VER 0.56 (18.04.1999)
// VER 0.57 (04.09.1999)
// VER 0.58 (09.10.1999)
// VER 0.59 (23.10.1999)

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif

#ifndef EXEC_PORTS_H
#include <exec/ports.h>
#endif

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef NOVIA_DATE_H
#include <novia/novia_date.h>
#endif


#define ITEMTYPE_NULL			0
#define ITEMTYPE_SUBBOARD		1
#define ITEMTYPE_MESSAGE		2
#define ITEMTYPE_FILEARCHIV	3
#define ITEMTYPE_EMAIL			4
#define ITEMTYPE_COMMAND		10

#define GENDER_BOTH			0
#define GENDER_FEMALE		'F'
#define GENDER_MALE			'M'

struct ItemInfoBlock
{
	ItemInfoBlock *ln_Succ;		// 4	new since V0.15 (vorher IDNumber)
	ItemInfoBlock *ln_Pred;		// 8	new since V0.15 (vorher IPNumber)

	UWORD	StructureType;			// 10
	UWORD ItemType;				// 12

	ULONG	IPNumber64;				// 16		offset changed since V0.15, oldoffset was 4
	ULONG	IPNumber;				// 20	

*	ULONG	CreateUSN64;			// 24
*	ULONG	CreateUSN;				// 28

*	ULONG	LastChangeUSN64;		// 32
*	ULONG	LastChangeUSN;			// 36

*	ULONG OwnerUSN64;				// 40		UUCP-UserID
*	ULONG OwnerUSN;				// 44

*	Date	ReservedDate;			// 56
*	Date	LastChange;				// 68
*	Date	CreateDate;				// 80		true writing date FileInfoBlock

*	ULONG	Size64;					// 84		sizeof File or size of files in subboard
*	ULONG	Size;						// 88		for 64Bit Filesystems or soft-dirs (FTP-Server)

*	ULONG	NumBlocks64;			// 92		copy of FileInfoBlock->fib_NumBlocks
*	ULONG	NumBlocks;				// 96		for 64Bit Filesystem (not yet supported)

*	ULONG	Protection;				// 100	DOS-Protection Bits

*	UBYTE	NoItems;					// 101	user can't add a item/reply to subboard/item
*	UBYTE	Deleted;					// 102	Item is deleted
*	UBYTE	Offline;					// 103	Closed
	UBYTE Visible;					// 104

*	UWORD	DownBytes;				// 106	x of download bytes to subtract
*	UWORD	DownFiles;				// 108	# of files to subtract per download
*	UWORD	TimeCredit;				// 110	% of time to give back for uploads

*	char	Title[108];				// 218	viewtitle
*	char	Filename[80];			// 298	copy of FileInfoBlock->fib_FileName
*	char	Comment[80];			// 378	copy of FileInfoBlock->fib_Comment

*	MinList OpenList;				// 304	List of port of open this file
*	char	*fullpath;				// 496	full filename
*	ULONG	OpenCounter;			// 500	OpenCounter

	Date	ExpirationDate;		// 536  auto-killing on ... 
	UWORD	ExpirationDays;		// 538	auto-killing in .. days 

};

*	ULONG	ReplyAccess;			// 132


struct Directory
{
	struct	ItemInfoBlock iib;// 512
d	ULONG	MinFreeBytes;			// 516    to upload in this subboard 
d	UBYTE	BufferType;				// 517	0 - no buffering
										//		1 - copy to ram before download
										//		2 - copy to harddisk before download
d	UBYTE	ArcTransform;			// 151 Transform to archiveformat
d	UBYTE	RealNames;				// 152 use real names instead of Handles? 
d	UBYTE	PrivateMails;			// 153
d	UBYTE	Anonymous;				// 155
d	UWORD	MinEnter;				// 136 minutes must online before enter of read subboard/item

d	UBYTE	Youngest;				// 137
d	UBYTE	Oldest;					// 138
d	UBYTE	Gender;					// 139
d	UBYTE	DefDropped;				// 140

d	UWORD	MaxMins;					// 142 User can't read/enter item/subboard after ...
d	UWORD	FreeDays;				// 144 files are free in ... days
q	ULONG	AccessLevel;			// 108	min Access

qd	ULONG	PostAccess;				// 112 groups which may Post
qd	ULONG	UploadAccess;			// 116 ... Upload/Respong access
qd	ULONG	DownloadAccess;		// 120 ... Download/Read access
qd	ULONG	ComputerTypes;			// 124

d	UBYTE	ArcAvailable;			// 518  Transform to archiveformat
d	UBYTE	QWKAvailable;			// 519 use real names instead of Handles? 
	UBYTE	FileTransform;			// 547 run script at upload time 

d	UBYTE	Verification;			// 520
d	UBYTE	ShowUnvalidated;		// 521
d	UBYTE	NoMCI;					// 522

d	UBYTE	PrivateArea;			// 523  0/1 No/Yes ... 2==FORCE 
d	char	Password[11];			// 534
d	char	Encrypt[11];			// 545
d	UBYTE	TestFiles;				// 546  test at upload time 

	UBYTE	ChangeOwnItems;		// 548 Use inactive days against indiv responses 

	UWORD	UpFileRatio;			// 552 Which file uploads ratio 
	UWORD	UpFileCharge;			// 554 which set of charges to use?          
	UWORD	UpByteRatio;			// 556
	UWORD	UpByteCharge;			// 558
	UWORD	UseRate;					// 560  default download rate
	
*	ULONG	Language;				// 564  which BBSARCS to transform

	ULONG	RecordLog;				// 568
	ULONG	LogfileID;				// 572
	
	ULONG	ItemEntrys;				// 576
	ULONG	DirEntrys;				// 580
	UWORD	DelMails;				// 582
	UWORD	DelFiles;				// 584
	UBYTE	AddressMessages;		// 585
	UBYTE	DupeCheck;				// 586
	UBYTE	NoPostCharges;			// 587
	UBYTE	PurgeOld;				// 588
	UBYTE	InvitatonOnly;			// 589
	UBYTE	NewVotes;				// 590
	UBYTE	NetworkType;			// 591
	UBYTE	reserved06172_338956;// 592
	ULONG	HoursOpen;				// 596
	ULONG	MaxItems;				// 600 Maximum Dirs & Items... in this subboard, 0 = no maximum
	char	Scanfilter[4];			// 604
	UBYTE	NewFilesValidation;	// 605
	UBYTE	AMaintAdoptOrphans;	// 606
	UBYTE	KillOwnFiles;			// 607
	UBYTE	localdir;
	MinList entrylist;			// 628 new sience V0.57 !!!
	BPTR	fh_messages;			
	BPTR	fh_files;
	BPTR	fh_dirs;
	BPTR	fh_text;
	BPTR	fh_replys;
	MinList subdirlist;			// 652 List of opened Sub-Directorys
	Directory *parrentdir;		// 656 pointer of parrent Directory-structure
	char	*parrentdir_name;		// 660
};


struct ItemEntry
{
	struct  ItemInfoBlock iib;	// 512  
	UBYTE	res;						// 539  reserved
	UBYTE	NetworkType;			// 540	>0 if uucp, fido or other mails
	ULONG	ItemType;				// 544	0 - mail
										//		   1 - archive

	ULONG	ToUser;					// 548  internal-items only
	ULONG	FromUser;				// 552  internal-items only
	ULONG	RealUser;				// 556  normaly a copy of FromUser. you can use this entry, if writers name is an alias or anonymous

	char	FromRealName[40];		// 676  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	From[80];				// 676  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	ToRealName[40];		// 796  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	To[80];					// 796  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	Alias[80];				// 876  alias name 

	char	anonymous;				// 877
	char	MailListMail;			// 878  MailList-Mail 
	char	ReservedFlags[6];		// 884 

	char	Filename[128];			// 1012 for fileitems only
	ULONG	FileVersion;			// 1016 Version of file 
	ULONG	MailListID;				// 1020 MailList ID Number 

	ULONG downloads;				// 1024

	ULONG	length;					// 1028
	ULONG	DirIP;					// 1032 serial directory number				// New in V0.14
	ULONG	replys;					// 1036
	char  *text;					// 1040
	ULONG	besttransfer;			// 1044
	ULONG first_reply;			// 1048
	ULONG	text_seek;				// 1052 Startseek in [Userpath]/MailData 
	UBYTE	resered[148];			// 1200
};


struct CommandEntry
{
	struct  ItemInfoBlock iib;	// 512  
	Date	SendDate;				// 524  import date in database 
	Date	ExpirationDate;		// 536  auto-killing on ... 
	UWORD	ExpirationDays;		// 538	auto-killing in .. days 
	UBYTE	NetworkType;			// 539	>0 if uucp, fido or other mails
	UBYTE	internal;				// 540  internal command
	ULONG	CommandID;				// 544  internal command id
	char	FromRealName[40];		// 584  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	From[80];				// 664  for FIDO,Z-Net,SMTP (RFC 821,822) Messages or other imported messages
	char	Alias[80];				// 744  alias name 
	ULONG	Version;					// 748  Version of command 
	ULONG runs;						// 752
	char	reserved1[256];		// 1008 for fileitems only
	UBYTE	reserved2[192];		// 1200
};


struct ReplyEntry {
	ULONG	IDNumber;				// 4
	ULONG	IPNumber;				// 8

	UBYTE	RealNames;				// 9 use real names instead of Handles? fileinfoblock
	UBYTE	PrivateMails;			// 10
	UBYTE	NoSignatures;			// 11
	UBYTE	Anonymous;				// 12
	UBYTE	Override;				// 13 how to set the use defaults flags in newly uploaded items 
	UBYTE	Deleted;					// 14 Item is deleted
	UBYTE	NoEdit;					// 15 User can't edit this mail 
	UBYTE	AnonymousMail;			// 16 
	UBYTE	MailListMail;			// 17 MailList-Mail 

	UBYTE	Reserved;				// 18
	UBYTE	TxtAdded;				// 19
	UBYTE	FileMail;				// 20 if TRUE txt=distrution
	char	FileName[40];			// 60

	Date	LastChange;				// 72
	Date	CreateDate;				// 84 true writing date

	ULONG	ToUser;					// 88 internal-items only 
	ULONG	FromUser;				// 92 internal-items only 
	Date	ExpirationDate;		// 104 auto-killing on ... 
	short	ExpirationDays;		// 106 auto-killing in .. days 
	
	char	From[80];				// 186 or alias name 
	char	FromRealName[40];		// 226
	char	To[80];					// 306
	char 	ToRealName[40];		// 346
	char	Alias[80];				// 426
	UBYTE	Reservedbytes[8];		// 434
	ULONG	length;					// 438
	Date	SendDate;				// 450 // new since V0.15 (imported date)
	ULONG unknown;					// 454
	ULONG next_reply;				// 458
	ULONG	text_seek;				// 462
	UBYTE res[24];					// 486
};
