 /**************************************************************************\
 *                                                                          
 * Object:      novia_user.c
 * Version:     $VER: 0.03 (05-Dec-1999)
 * Author:      Thorsten Gehler <campino@TUCHome.de>
 *
 *
 *
 * Copyright (c) 1996,1997,1998,1999 by Thorsten Gehler/UFoP.
 *
 * THIS SOFTWARE IS FREE: YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER
 * THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE
 * SOFTWARE FOUNDATION; VERSION 2, OR (AT YOUR OPTION) ANY LATER VERSION.
 *
 * FOR LICENSE TERMS, SEE THE FILE 'COPYING' IN THE MAIN DIRECTORY.
 * 
 *
 \**************************************************************************/ 

#include <novia/novia_global.h>
#include <novia/novia_misc.h>
#include <novia/novia_funcs.h>
#include <novia/novia_registers.h>
#include <dos/stdio.h>
#include <pragma/noviasys_lib.h>

extern Task *MainTask;

ULONG __saveds ASM nslib_SearchUser(register __a0 char *username);
ULONG __saveds ASM nslib_FindUser(register __a0 char *username);
struct UserNode * __saveds ASM nslib_GetUserByIP(register __a0 ULONG IPNumber);
void ShowUserList();
void SaveUserList(UserList *ulist);
void LoadUserList(UserList *ulist);
void __saveds ASM nslib_SaveUser(register __a0 UserData *pointer);
void __saveds ASM nslib_AddUser(register __a0 UserData *pointer);
BOOL __saveds ASM nslib_LoadUser(register __a0 UserData *pointer, register __d0 ULONG Usernumber);
char __saveds ASM nslib_CheckPassword(register __a0 char *buffer, register __d0 ULONG UserNumber);
void Termsettings(UserData *udata,char type);  // 0 - Show 1- Edit
void UserEdit(ULONG user);


ULONG __saveds ASM nslib_SearchUser(register __a0 char *username)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
	/*	char buffer[100];
		UserNode *start;
		ULONG counter;
		BPTR mulder;
		long index;
		char Quit=FALSE;
		StrToLong(username,(long *)&counter);
		if (*username==0 || *username==32)return 0;
		if (!strlen(username))
		{
			ioprintf("invalid Username.");
			return NULL;
		}
		if (counter>0)
		{
			if (counter<=cport->UL.UserEntrys)
			{
				if (cport->UL.utable[counter].Status)
				{
					sprintf(buffer,"Is %s correct ?",cport->UL.utable[counter].Handle);
					LF();Writeio(buffer,-1);
					if (Yesno(TRUE)==TRUE)return counter;
				}
			}
			else
				ioprintf("invalid UserID.");
		}
		else
		{
			for (counter=1;counter<=cport->UL.UserEntrys;counter++)
			{
				LONG result=stricmp(username,cport->UL.utable[counter].Handle);
				if (!result)
					return counter;
			}
		}
	*/
		return FindUser(username)
	}
}

struct UserNode * __saveds ASM nslib_GetUserByIP(register __a0 ULONG IPNumber)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	ioprintf("IP: %d",IPNumber);
	if (cport && IPNumber)
	{
		ULONG counter;
		for (counter = 1; counter<cport->UL.UserEntrys; counter++)
		{
			ioprintf("IPNumber: %d %d\n",cport->UL.utable[counter].IPNumber,IPNumber);
			if (cport->UL.utable[counter].IPNumber == IPNumber)
				return &cport->UL.utable[counter];
		}
	}
	return NULL;
}

ULONG __saveds ASM nslib_FindUser(register __a0 char *username)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		char buffer[100];
		UserNode *start;
		ULONG counter;
		BPTR mulder;
		long index;
		char Quit=FALSE;
		StrToLong(username,(long *)&counter);
		if (*username==0 || *username==32)return 0;
		if (!strlen(username))return NULL;
		if (counter>0)
		{
			if (counter <= cport->UL.UserEntrys)
			{
				if (cport->UL.utable[counter].Status)
					return counter;
			}
		}
		else
		{
			for (counter=1;counter<=cport->UL.UserEntrys;counter++)
			{
				if (!stricmp(username,cport->UL.utable[counter].Handle))
					return counter;
			}
		}
	}
	return NULL;
}

void ShowUserList()
{
	struct PortData *cport=(PortData *)FindTask("novia_main")->tc_UserData;
	if (cport)
	{
		char buffer[200];
		ULONG counter;
		UserNode *un;
		CLS();
		ioprintf("entrys: %d",cport->UL.UserEntrys);
		for (counter=1;counter<=cport->UL.UserEntrys;counter++)
		{
			un=&cport->UL.utable[counter];
			LoadUser(&cport->EditUser,counter);
	//		ioprintf("Username: %20s %3d,%3d - %20s %3d,%3d\n",un->Handle,un->IDNumber,un->IPNumber,cport->EditUser.Handle,cport->EditUser.IDNumber,cport->EditUser.IPNumber);
			ioprintf("Username: %s %d,%d - %s %d,%d\n",un->Handle,un->IDNumber,un->IPNumber,cport->EditUser.Handle,cport->EditUser.IDNumber,cport->EditUser.IPNumber);
		}
	}
}

void SaveUserList(UserList *ulist)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		UserNode *start;
		ULONG counter;
		BPTR mulder;
		char buffer[100];
		sprintf(buffer,"%ssys.userdata.a",cport->sysdirs->sysdata);
		mulder=Open(buffer,MODE_NEWFILE);
		if (mulder==NULL)return;
		FWrite(mulder,&ulist->UserEntrys,4,1);
		FWrite(mulder,&ulist->utable[1],sizeof(UserNode)*ulist->UserEntrys,1);
		Close(mulder);
	}
}

void LoadUserList(UserList *ulist)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		UserNode *usernode;
		ULONG users = NULL;
		BPTR mulder;
		char buffer[100];
		ioprintf("loading UserList...");
		sprintf(buffer,"%ssys.userdata.b",cport->sysdirs->sysdata);
		ChangeScreenStatus("Loading UserList");
		if ((mulder = Open(buffer,MODE_OLDFILE)))
		{
			Seek(mulder,0,OFFSET_END);
			users 	= Seek(mulder,0,OFFSET_BEGINNING);
			if (users)
			{
				users = users/sizeof(UserData);
				
				ioprintf("%d users found",users);
				if ((ulist->utable = (UserNode *)AllocVec((users+1)*sizeof(UserNode),MEMF_ANY|MEMF_CLEAR)))
				{
					usernode = &ulist->utable[1];
					while (Read(mulder, &cport->EditUser, sizeof(UserData)) == sizeof(UserData))
					{
						usernode->IDNumber			= cport->EditUser.IDNumber;
						usernode->IPNumber			= cport->EditUser.IPNumber;
						usernode->Status				= cport->EditUser.Status;
						strncpy(usernode->Handle,	  cport->EditUser.Handle,21);

						usernode->Access				= cport->EditUser.Access;
						usernode->AccessGroup		= cport->EditUser.AccessGroup;
						strncpy(usernode->RealName,  cport->EditUser.RealName,41);
						strncpy(usernode->Street,	  cport->EditUser.Street,41);
						strncpy(usernode->City,		  cport->EditUser.City,31);
						strncpy(usernode->ZipCode,	  cport->EditUser.ZipCode,11);
						usernode->CountryCode		= cport->EditUser.CountryCode;
						strncpy(usernode->Country,	  cport->EditUser.Country,4);

						strncpy(usernode->AreaCode,  cport->EditUser.AreaCode,8);
						strncpy(usernode->Area,		  cport->EditUser.Area,17);
						strncpy(usernode->PhoneNo,	  cport->EditUser.PhoneNo,25);
						strncpy(usernode->ModemNo,	  cport->EditUser.ModemNo,25);
						strncpy(usernode->FaxNo,	  cport->EditUser.FaxNo,25);
						usernode->ComputerType		= cport->EditUser.ComputerType;
						CopyMemQuick(&usernode->Birthday		,&cport->EditUser.Birthday,12);
						CopyMemQuick(&usernode->FirstCall	,&cport->EditUser.FirstCall,12);
						CopyMemQuick(&usernode->LastCall		,&cport->EditUser.LastCall,12);
						CopyMemQuick(&usernode->ExpireDate	,&cport->EditUser.ExpireDate,12);
						usernode->ExpireDays			= cport->EditUser.ExpireDays;

						usernode->Sex					= cport->EditUser.Sex;
						usernode->Language			= cport->EditUser.Language;

						strncpy(usernode->UUCP,		  cport->EditUser.UUCP,31);
						strncpy(usernode->Data_dir,  cport->EditUser.Data_dir,31);

						usernode++;
					}
					CR();ioprintf("[70Cc2donec7\n");
				}
				else
				{
					ioprintf("out of memory.\n");
					CR();ioprintf("[70Cc1failatc7\n");
				}
			}
			else
			{
				ioprintf(" no entrys found.\n");
				CR();ioprintf("[70Cc1failatc7\n");
			}
			Close(mulder);
		}
		else
		{
			ioprintf(" can't open %s",buffer);
			CR();ioprintf("[70Cc1failatc7\n");
		}
		ulist->UserEntrys = users;
	}
}
	
void __saveds ASM nslib_SaveUser(register __a0 UserData *pointer)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		BPTR mulder;
		char buffer[100];
		sprintf(buffer,"%ssys.userdata.b",cport->sysdirs->sysdata);
		mulder=Open(buffer,MODE_READWRITE);
		if (mulder==NULL)return;
		Seek(mulder,(pointer->IDNumber-1)*sizeof(UserData),OFFSET_BEGINNING);
		FWrite(mulder,pointer,sizeof(UserData),1);
		Close(mulder);
	}

	if (pointer->IDNumber<=cport->UL.UserEntrys)
	{
		strncpy(cport->UL.utable[pointer->IDNumber].Handle,pointer->Handle,20);
	}

}


void __saveds ASM nslib_AddUser(register __a0 UserData *pointer)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		UserNode *start=AllocVec(sizeof(UserNode)*cport->UL.UserEntrys+2,MEMF_ANY|MEMF_CLEAR);
		pointer->IDNumber=cport->UL.UserEntrys++;
		pointer->IPNumber=0;
		pointer->Status=TRUE;
		if (!start)return;
		CopyMem(cport->UL.utable,start,sizeof(UserNode)*cport->UL.UserEntrys);
		start[pointer->IDNumber].IDNumber=pointer->IDNumber;
		start[pointer->IDNumber].IPNumber=pointer->IPNumber;
		start[pointer->IDNumber].Status=TRUE;
		strcpy(start[pointer->IDNumber].Handle,pointer->Handle);
		FreeVec(cport->UL.utable);
		cport->UL.utable=start;
		SaveUserList(&cport->UL);
		SaveUser(pointer);
	}
}


BOOL __saveds ASM nslib_LoadUser(register __a0 UserData *pointer, register __d0 ULONG Usernumber)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		BPTR mulder;
		char buffer[100];
		sprintf(buffer,"%ssys.userdata.b",cport->sysdirs->sysdata);
		if (Usernumber>0)
		{
			if (mulder=Open(buffer,MODE_OLDFILE))
			{
				Seek(mulder,0,OFFSET_END);
				if (Seek(mulder,0,OFFSET_END)<((Usernumber)*sizeof(UserData))-1)
					return FALSE;
				else
				{
					Seek(mulder,(Usernumber-1)*sizeof(UserData),OFFSET_BEGINNING);
					Read(mulder,pointer,sizeof(UserData));
					Close(mulder);	
					return TRUE;
				}
			}
			else
			{
				return FALSE;
			}
		}
		else
		{
			return FALSE;
		}
	}
}



char __saveds ASM nslib_CheckPassword(register __a0 char *buffer, register __d0 ULONG UserNumber)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		LONG index;
		char buffer2[100];
		BPTR mulder;
		sprintf(buffer2,"%ssys.userdata.b",cport->sysdirs->sysdata);
		mulder=Open(buffer2,MODE_OLDFILE);
		if(mulder==NULL)return FALSE;
		Seek(mulder,((UserNumber-1)*sizeof(UserData))+30,OFFSET_BEGINNING);
		FRead(mulder,buffer2,21,1);
		Close(mulder);
		index=stricmp(buffer2,buffer);
		if (!index)return TRUE;
		return TRUE;
	}
}

void Termsettings(UserData *udata,char type)  // 0 - Show 1- Edit
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		LF();ioprintf("                 Terminal settings:\n\n");
	 	ioprintf(" 1) Computer type:                       2) Graphics set :\n");
		ioprintf(" 3) ANSI support :                       4) Line feeds   :\n");
		ioprintf(" 5) Screen width :                       6) Screen height:\n");
		ioprintf(" 7) ANSI tabs    :                       8) ANSI color   :\n\n");
		Writeio("5A19C",-1);
		if (udata->ComputerType==0)Writeio("Amiga          ",-1);
		if (udata->ComputerType==1)Writeio("Apple Macintosh",-1);
		if (udata->ComputerType==2)Writeio("IBM PC         ",-1);
		if (udata->ComputerType==3)Writeio("UNIC Based     ",-1);
		if (udata->ComputerType==4)Writeio("Other terminals",-1);
		Writeio("[25CNOT IN USE",-1);
		LF();Writeio("[19CNOT IN USE",-1);
		Writeio("[30CNOT IN USE",-1);
		LF();Writeio("[19C",-1);Writelong((ULONG)udata->TermWidth);CSI(0x0d);
		Writeio("[59C",-1);Writelong((ULONG)udata->TermLength);LF();
		ioprintf("Enter the # of the item to change, or press ENTER to continue.\n");
		Writeio(":> ",-1);
	}
}

void UserEdit(ULONG user)
{
	struct PortData *cport=(PortData *)MainTask->tc_UserData;
	if (cport)
	{
		if (LoadUser(&cport->EditUser,user)==FALSE)
		{
			ioprintf("LoadUser() failat. call microsoft hotline.\nCan't load user: %d\n",user);
			return;
		}
		execute_nsl("novia:scripts/edit_user.nsl");
	}
}	



